// Compiled by ClojureScript 1.7.170 {:static-fns true, :optimize-constants true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args36199 = [];
var len__5740__auto___36205 = arguments.length;
var i__5741__auto___36206 = (0);
while(true){
if((i__5741__auto___36206 < len__5740__auto___36205)){
args36199.push((arguments[i__5741__auto___36206]));

var G__36207 = (i__5741__auto___36206 + (1));
i__5741__auto___36206 = G__36207;
continue;
} else {
}
break;
}

var G__36201 = args36199.length;
switch (G__36201) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36199.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async36202 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36202 = (function (f,blockable,meta36203){
this.f = f;
this.blockable = blockable;
this.meta36203 = meta36203;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36204,meta36203__$1){
var self__ = this;
var _36204__$1 = this;
return (new cljs.core.async.t_cljs$core$async36202(self__.f,self__.blockable,meta36203__$1));
});

cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36204){
var self__ = this;
var _36204__$1 = this;
return self__.meta36203;
});

cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async36202.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async36202.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$blockable,cljs.core.cst$sym$meta36203], null);
});

cljs.core.async.t_cljs$core$async36202.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36202.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36202";

cljs.core.async.t_cljs$core$async36202.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36202");
});

cljs.core.async.__GT_t_cljs$core$async36202 = (function cljs$core$async$__GT_t_cljs$core$async36202(f__$1,blockable__$1,meta36203){
return (new cljs.core.async.t_cljs$core$async36202(f__$1,blockable__$1,meta36203));
});

}

return (new cljs.core.async.t_cljs$core$async36202(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args36211 = [];
var len__5740__auto___36214 = arguments.length;
var i__5741__auto___36215 = (0);
while(true){
if((i__5741__auto___36215 < len__5740__auto___36214)){
args36211.push((arguments[i__5741__auto___36215]));

var G__36216 = (i__5741__auto___36215 + (1));
i__5741__auto___36215 = G__36216;
continue;
} else {
}
break;
}

var G__36213 = args36211.length;
switch (G__36213) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36211.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.cst$sym$buf_DASH_or_DASH_n], 0)))].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args36218 = [];
var len__5740__auto___36221 = arguments.length;
var i__5741__auto___36222 = (0);
while(true){
if((i__5741__auto___36222 < len__5740__auto___36221)){
args36218.push((arguments[i__5741__auto___36222]));

var G__36223 = (i__5741__auto___36222 + (1));
i__5741__auto___36222 = G__36223;
continue;
} else {
}
break;
}

var G__36220 = args36218.length;
switch (G__36220) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36218.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args36225 = [];
var len__5740__auto___36228 = arguments.length;
var i__5741__auto___36229 = (0);
while(true){
if((i__5741__auto___36229 < len__5740__auto___36228)){
args36225.push((arguments[i__5741__auto___36229]));

var G__36230 = (i__5741__auto___36229 + (1));
i__5741__auto___36229 = G__36230;
continue;
} else {
}
break;
}

var G__36227 = args36225.length;
switch (G__36227) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36225.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_36232 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36232) : fn1.call(null,val_36232));
} else {
cljs.core.async.impl.dispatch.run(((function (val_36232,ret){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_36232) : fn1.call(null,val_36232));
});})(val_36232,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args36233 = [];
var len__5740__auto___36236 = arguments.length;
var i__5741__auto___36237 = (0);
while(true){
if((i__5741__auto___36237 < len__5740__auto___36236)){
args36233.push((arguments[i__5741__auto___36237]));

var G__36238 = (i__5741__auto___36237 + (1));
i__5741__auto___36237 = G__36238;
continue;
} else {
}
break;
}

var G__36235 = args36233.length;
switch (G__36235) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36233.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4651__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4651__auto__)){
var ret = temp__4651__auto__;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4651__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__4651__auto__)){
var retb = temp__4651__auto__;
var ret = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(retb) : cljs.core.deref.call(null,retb));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__4651__auto__){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
});})(ret,retb,temp__4651__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5585__auto___36240 = n;
var x_36241 = (0);
while(true){
if((x_36241 < n__5585__auto___36240)){
(a[x_36241] = (0));

var G__36242 = (x_36241 + (1));
x_36241 = G__36242;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__36243 = (i + (1));
i = G__36243;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true) : cljs.core.atom.call(null,true));
if(typeof cljs.core.async.t_cljs$core$async36247 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36247 = (function (alt_flag,flag,meta36248){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta36248 = meta36248;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_36249,meta36248__$1){
var self__ = this;
var _36249__$1 = this;
return (new cljs.core.async.t_cljs$core$async36247(self__.alt_flag,self__.flag,meta36248__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_36249){
var self__ = this;
var _36249__$1 = this;
return self__.meta36248;
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.flag) : cljs.core.deref.call(null,self__.flag));
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.flag,null) : cljs.core.reset_BANG_.call(null,self__.flag,null));

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_flag,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$meta36248], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async36247.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36247.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36247";

cljs.core.async.t_cljs$core$async36247.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36247");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async36247 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async36247(alt_flag__$1,flag__$1,meta36248){
return (new cljs.core.async.t_cljs$core$async36247(alt_flag__$1,flag__$1,meta36248));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async36247(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async36253 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async36253 = (function (alt_handler,flag,cb,meta36254){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta36254 = meta36254;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_36255,meta36254__$1){
var self__ = this;
var _36255__$1 = this;
return (new cljs.core.async.t_cljs$core$async36253(self__.alt_handler,self__.flag,self__.cb,meta36254__$1));
});

cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_36255){
var self__ = this;
var _36255__$1 = this;
return self__.meta36254;
});

cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async36253.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async36253.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_handler,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$cb], null)))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$cb,cljs.core.cst$sym$meta36254], null);
});

cljs.core.async.t_cljs$core$async36253.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async36253.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async36253";

cljs.core.async.t_cljs$core$async36253.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async36253");
});

cljs.core.async.__GT_t_cljs$core$async36253 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async36253(alt_handler__$1,flag__$1,cb__$1,meta36254){
return (new cljs.core.async.t_cljs$core$async36253(alt_handler__$1,flag__$1,cb__$1,meta36254));
});

}

return (new cljs.core.async.t_cljs$core$async36253(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = cljs.core.cst$kw$priority.cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__36256_SHARP_){
var G__36260 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__36256_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__36260) : fret.call(null,G__36260));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__36257_SHARP_){
var G__36261 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__36257_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__36261) : fret.call(null,G__36261));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(vbox) : cljs.core.deref.call(null,vbox)),(function (){var or__4682__auto__ = wport;
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
return port;
}
})()], null));
} else {
var G__36262 = (i + (1));
i = G__36262;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4682__auto__ = ret;
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,cljs.core.cst$kw$default)){
var temp__4653__auto__ = (function (){var and__4670__auto__ = cljs.core.async.impl.protocols.active_QMARK_(flag);
if(cljs.core.truth_(and__4670__auto__)){
return cljs.core.async.impl.protocols.commit(flag);
} else {
return and__4670__auto__;
}
})();
if(cljs.core.truth_(temp__4653__auto__)){
var got = temp__4653__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$default.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$default], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__5747__auto__ = [];
var len__5740__auto___36268 = arguments.length;
var i__5741__auto___36269 = (0);
while(true){
if((i__5741__auto___36269 < len__5740__auto___36268)){
args__5747__auto__.push((arguments[i__5741__auto___36269]));

var G__36270 = (i__5741__auto___36269 + (1));
i__5741__auto___36269 = G__36270;
continue;
} else {
}
break;
}

var argseq__5748__auto__ = ((((1) < args__5747__auto__.length))?(new cljs.core.IndexedSeq(args__5747__auto__.slice((1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5748__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__36265){
var map__36266 = p__36265;
var map__36266__$1 = ((((!((map__36266 == null)))?((((map__36266.cljs$lang$protocol_mask$partition0$ & (64))) || (map__36266.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__36266):map__36266);
var opts = map__36266__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq36263){
var G__36264 = cljs.core.first(seq36263);
var seq36263__$1 = cljs.core.next(seq36263);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__36264,seq36263__$1);
});
/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args36271 = [];
var len__5740__auto___36321 = arguments.length;
var i__5741__auto___36322 = (0);
while(true){
if((i__5741__auto___36322 < len__5740__auto___36321)){
args36271.push((arguments[i__5741__auto___36322]));

var G__36323 = (i__5741__auto___36322 + (1));
i__5741__auto___36322 = G__36323;
continue;
} else {
}
break;
}

var G__36273 = args36271.length;
switch (G__36273) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36271.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__36154__auto___36325 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___36325){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___36325){
return (function (state_36297){
var state_val_36298 = (state_36297[(1)]);
if((state_val_36298 === (7))){
var inst_36293 = (state_36297[(2)]);
var state_36297__$1 = state_36297;
var statearr_36299_36326 = state_36297__$1;
(statearr_36299_36326[(2)] = inst_36293);

(statearr_36299_36326[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (1))){
var state_36297__$1 = state_36297;
var statearr_36300_36327 = state_36297__$1;
(statearr_36300_36327[(2)] = null);

(statearr_36300_36327[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (4))){
var inst_36276 = (state_36297[(7)]);
var inst_36276__$1 = (state_36297[(2)]);
var inst_36277 = (inst_36276__$1 == null);
var state_36297__$1 = (function (){var statearr_36301 = state_36297;
(statearr_36301[(7)] = inst_36276__$1);

return statearr_36301;
})();
if(cljs.core.truth_(inst_36277)){
var statearr_36302_36328 = state_36297__$1;
(statearr_36302_36328[(1)] = (5));

} else {
var statearr_36303_36329 = state_36297__$1;
(statearr_36303_36329[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (13))){
var state_36297__$1 = state_36297;
var statearr_36304_36330 = state_36297__$1;
(statearr_36304_36330[(2)] = null);

(statearr_36304_36330[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (6))){
var inst_36276 = (state_36297[(7)]);
var state_36297__$1 = state_36297;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36297__$1,(11),to,inst_36276);
} else {
if((state_val_36298 === (3))){
var inst_36295 = (state_36297[(2)]);
var state_36297__$1 = state_36297;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36297__$1,inst_36295);
} else {
if((state_val_36298 === (12))){
var state_36297__$1 = state_36297;
var statearr_36305_36331 = state_36297__$1;
(statearr_36305_36331[(2)] = null);

(statearr_36305_36331[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (2))){
var state_36297__$1 = state_36297;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36297__$1,(4),from);
} else {
if((state_val_36298 === (11))){
var inst_36286 = (state_36297[(2)]);
var state_36297__$1 = state_36297;
if(cljs.core.truth_(inst_36286)){
var statearr_36306_36332 = state_36297__$1;
(statearr_36306_36332[(1)] = (12));

} else {
var statearr_36307_36333 = state_36297__$1;
(statearr_36307_36333[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (9))){
var state_36297__$1 = state_36297;
var statearr_36308_36334 = state_36297__$1;
(statearr_36308_36334[(2)] = null);

(statearr_36308_36334[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (5))){
var state_36297__$1 = state_36297;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36309_36335 = state_36297__$1;
(statearr_36309_36335[(1)] = (8));

} else {
var statearr_36310_36336 = state_36297__$1;
(statearr_36310_36336[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (14))){
var inst_36291 = (state_36297[(2)]);
var state_36297__$1 = state_36297;
var statearr_36311_36337 = state_36297__$1;
(statearr_36311_36337[(2)] = inst_36291);

(statearr_36311_36337[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (10))){
var inst_36283 = (state_36297[(2)]);
var state_36297__$1 = state_36297;
var statearr_36312_36338 = state_36297__$1;
(statearr_36312_36338[(2)] = inst_36283);

(statearr_36312_36338[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36298 === (8))){
var inst_36280 = cljs.core.async.close_BANG_(to);
var state_36297__$1 = state_36297;
var statearr_36313_36339 = state_36297__$1;
(statearr_36313_36339[(2)] = inst_36280);

(statearr_36313_36339[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___36325))
;
return ((function (switch__36040__auto__,c__36154__auto___36325){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_36317 = [null,null,null,null,null,null,null,null];
(statearr_36317[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_36317[(1)] = (1));

return statearr_36317;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_36297){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36297);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36318){if((e36318 instanceof Object)){
var ex__36044__auto__ = e36318;
var statearr_36319_36340 = state_36297;
(statearr_36319_36340[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36297);

return cljs.core.cst$kw$recur;
} else {
throw e36318;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36341 = state_36297;
state_36297 = G__36341;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_36297){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_36297);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___36325))
})();
var state__36156__auto__ = (function (){var statearr_36320 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36320[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36325);

return statearr_36320;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___36325))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$pos_QMARK_,cljs.core.cst$sym$n)], 0)))].join('')));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = ((function (jobs,results){
return (function (p__36525){
var vec__36526 = p__36525;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36526,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36526,(1),null);
var job = vec__36526;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__36154__auto___36708 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results){
return (function (state_36531){
var state_val_36532 = (state_36531[(1)]);
if((state_val_36532 === (1))){
var state_36531__$1 = state_36531;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36531__$1,(2),res,v);
} else {
if((state_val_36532 === (2))){
var inst_36528 = (state_36531[(2)]);
var inst_36529 = cljs.core.async.close_BANG_(res);
var state_36531__$1 = (function (){var statearr_36533 = state_36531;
(statearr_36533[(7)] = inst_36528);

return statearr_36533;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_36531__$1,inst_36529);
} else {
return null;
}
}
});})(c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results))
;
return ((function (switch__36040__auto__,c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_36537 = [null,null,null,null,null,null,null,null];
(statearr_36537[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__);

(statearr_36537[(1)] = (1));

return statearr_36537;
});
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1 = (function (state_36531){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36531);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36538){if((e36538 instanceof Object)){
var ex__36044__auto__ = e36538;
var statearr_36539_36709 = state_36531;
(statearr_36539_36709[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36531);

return cljs.core.cst$kw$recur;
} else {
throw e36538;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36710 = state_36531;
state_36531 = G__36710;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = function(state_36531){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1.call(this,state_36531);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results))
})();
var state__36156__auto__ = (function (){var statearr_36540 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36540[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36708);

return statearr_36540;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___36708,res,vec__36526,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__36541){
var vec__36542 = p__36541;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36542,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__36542,(1),null);
var job = vec__36542;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results,process))
;
var n__5585__auto___36711 = n;
var __36712 = (0);
while(true){
if((__36712 < n__5585__auto___36711)){
var G__36543_36713 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__36543_36713) {
case "compute":
var c__36154__auto___36715 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36712,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (__36712,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function (state_36556){
var state_val_36557 = (state_36556[(1)]);
if((state_val_36557 === (1))){
var state_36556__$1 = state_36556;
var statearr_36558_36716 = state_36556__$1;
(statearr_36558_36716[(2)] = null);

(statearr_36558_36716[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36557 === (2))){
var state_36556__$1 = state_36556;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36556__$1,(4),jobs);
} else {
if((state_val_36557 === (3))){
var inst_36554 = (state_36556[(2)]);
var state_36556__$1 = state_36556;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36556__$1,inst_36554);
} else {
if((state_val_36557 === (4))){
var inst_36546 = (state_36556[(2)]);
var inst_36547 = process(inst_36546);
var state_36556__$1 = state_36556;
if(cljs.core.truth_(inst_36547)){
var statearr_36559_36717 = state_36556__$1;
(statearr_36559_36717[(1)] = (5));

} else {
var statearr_36560_36718 = state_36556__$1;
(statearr_36560_36718[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36557 === (5))){
var state_36556__$1 = state_36556;
var statearr_36561_36719 = state_36556__$1;
(statearr_36561_36719[(2)] = null);

(statearr_36561_36719[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36557 === (6))){
var state_36556__$1 = state_36556;
var statearr_36562_36720 = state_36556__$1;
(statearr_36562_36720[(2)] = null);

(statearr_36562_36720[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36557 === (7))){
var inst_36552 = (state_36556[(2)]);
var state_36556__$1 = state_36556;
var statearr_36563_36721 = state_36556__$1;
(statearr_36563_36721[(2)] = inst_36552);

(statearr_36563_36721[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__36712,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
;
return ((function (__36712,switch__36040__auto__,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_36567 = [null,null,null,null,null,null,null];
(statearr_36567[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__);

(statearr_36567[(1)] = (1));

return statearr_36567;
});
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1 = (function (state_36556){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36556);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36568){if((e36568 instanceof Object)){
var ex__36044__auto__ = e36568;
var statearr_36569_36722 = state_36556;
(statearr_36569_36722[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36556);

return cljs.core.cst$kw$recur;
} else {
throw e36568;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36723 = state_36556;
state_36556 = G__36723;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = function(state_36556){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1.call(this,state_36556);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__;
})()
;})(__36712,switch__36040__auto__,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
})();
var state__36156__auto__ = (function (){var statearr_36570 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36570[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36715);

return statearr_36570;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(__36712,c__36154__auto___36715,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
);


break;
case "async":
var c__36154__auto___36724 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__36712,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (__36712,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function (state_36583){
var state_val_36584 = (state_36583[(1)]);
if((state_val_36584 === (1))){
var state_36583__$1 = state_36583;
var statearr_36585_36725 = state_36583__$1;
(statearr_36585_36725[(2)] = null);

(statearr_36585_36725[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36584 === (2))){
var state_36583__$1 = state_36583;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36583__$1,(4),jobs);
} else {
if((state_val_36584 === (3))){
var inst_36581 = (state_36583[(2)]);
var state_36583__$1 = state_36583;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36583__$1,inst_36581);
} else {
if((state_val_36584 === (4))){
var inst_36573 = (state_36583[(2)]);
var inst_36574 = async(inst_36573);
var state_36583__$1 = state_36583;
if(cljs.core.truth_(inst_36574)){
var statearr_36586_36726 = state_36583__$1;
(statearr_36586_36726[(1)] = (5));

} else {
var statearr_36587_36727 = state_36583__$1;
(statearr_36587_36727[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36584 === (5))){
var state_36583__$1 = state_36583;
var statearr_36588_36728 = state_36583__$1;
(statearr_36588_36728[(2)] = null);

(statearr_36588_36728[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36584 === (6))){
var state_36583__$1 = state_36583;
var statearr_36589_36729 = state_36583__$1;
(statearr_36589_36729[(2)] = null);

(statearr_36589_36729[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36584 === (7))){
var inst_36579 = (state_36583[(2)]);
var state_36583__$1 = state_36583;
var statearr_36590_36730 = state_36583__$1;
(statearr_36590_36730[(2)] = inst_36579);

(statearr_36590_36730[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__36712,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
;
return ((function (__36712,switch__36040__auto__,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_36594 = [null,null,null,null,null,null,null];
(statearr_36594[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__);

(statearr_36594[(1)] = (1));

return statearr_36594;
});
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1 = (function (state_36583){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36583);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36595){if((e36595 instanceof Object)){
var ex__36044__auto__ = e36595;
var statearr_36596_36731 = state_36583;
(statearr_36596_36731[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36583);

return cljs.core.cst$kw$recur;
} else {
throw e36595;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36732 = state_36583;
state_36583 = G__36732;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = function(state_36583){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1.call(this,state_36583);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__;
})()
;})(__36712,switch__36040__auto__,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
})();
var state__36156__auto__ = (function (){var statearr_36597 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36597[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36724);

return statearr_36597;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(__36712,c__36154__auto___36724,G__36543_36713,n__5585__auto___36711,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__36733 = (__36712 + (1));
__36712 = G__36733;
continue;
} else {
}
break;
}

var c__36154__auto___36734 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___36734,jobs,results,process,async){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___36734,jobs,results,process,async){
return (function (state_36619){
var state_val_36620 = (state_36619[(1)]);
if((state_val_36620 === (1))){
var state_36619__$1 = state_36619;
var statearr_36621_36735 = state_36619__$1;
(statearr_36621_36735[(2)] = null);

(statearr_36621_36735[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36620 === (2))){
var state_36619__$1 = state_36619;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36619__$1,(4),from);
} else {
if((state_val_36620 === (3))){
var inst_36617 = (state_36619[(2)]);
var state_36619__$1 = state_36619;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36619__$1,inst_36617);
} else {
if((state_val_36620 === (4))){
var inst_36600 = (state_36619[(7)]);
var inst_36600__$1 = (state_36619[(2)]);
var inst_36601 = (inst_36600__$1 == null);
var state_36619__$1 = (function (){var statearr_36622 = state_36619;
(statearr_36622[(7)] = inst_36600__$1);

return statearr_36622;
})();
if(cljs.core.truth_(inst_36601)){
var statearr_36623_36736 = state_36619__$1;
(statearr_36623_36736[(1)] = (5));

} else {
var statearr_36624_36737 = state_36619__$1;
(statearr_36624_36737[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36620 === (5))){
var inst_36603 = cljs.core.async.close_BANG_(jobs);
var state_36619__$1 = state_36619;
var statearr_36625_36738 = state_36619__$1;
(statearr_36625_36738[(2)] = inst_36603);

(statearr_36625_36738[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36620 === (6))){
var inst_36600 = (state_36619[(7)]);
var inst_36605 = (state_36619[(8)]);
var inst_36605__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_36606 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_36607 = [inst_36600,inst_36605__$1];
var inst_36608 = (new cljs.core.PersistentVector(null,2,(5),inst_36606,inst_36607,null));
var state_36619__$1 = (function (){var statearr_36626 = state_36619;
(statearr_36626[(8)] = inst_36605__$1);

return statearr_36626;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36619__$1,(8),jobs,inst_36608);
} else {
if((state_val_36620 === (7))){
var inst_36615 = (state_36619[(2)]);
var state_36619__$1 = state_36619;
var statearr_36627_36739 = state_36619__$1;
(statearr_36627_36739[(2)] = inst_36615);

(statearr_36627_36739[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36620 === (8))){
var inst_36605 = (state_36619[(8)]);
var inst_36610 = (state_36619[(2)]);
var state_36619__$1 = (function (){var statearr_36628 = state_36619;
(statearr_36628[(9)] = inst_36610);

return statearr_36628;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36619__$1,(9),results,inst_36605);
} else {
if((state_val_36620 === (9))){
var inst_36612 = (state_36619[(2)]);
var state_36619__$1 = (function (){var statearr_36629 = state_36619;
(statearr_36629[(10)] = inst_36612);

return statearr_36629;
})();
var statearr_36630_36740 = state_36619__$1;
(statearr_36630_36740[(2)] = null);

(statearr_36630_36740[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___36734,jobs,results,process,async))
;
return ((function (switch__36040__auto__,c__36154__auto___36734,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_36634 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_36634[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__);

(statearr_36634[(1)] = (1));

return statearr_36634;
});
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1 = (function (state_36619){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36619);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36635){if((e36635 instanceof Object)){
var ex__36044__auto__ = e36635;
var statearr_36636_36741 = state_36619;
(statearr_36636_36741[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36619);

return cljs.core.cst$kw$recur;
} else {
throw e36635;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36742 = state_36619;
state_36619 = G__36742;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = function(state_36619){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1.call(this,state_36619);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___36734,jobs,results,process,async))
})();
var state__36156__auto__ = (function (){var statearr_36637 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36637[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36734);

return statearr_36637;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___36734,jobs,results,process,async))
);


var c__36154__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto__,jobs,results,process,async){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto__,jobs,results,process,async){
return (function (state_36675){
var state_val_36676 = (state_36675[(1)]);
if((state_val_36676 === (7))){
var inst_36671 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
var statearr_36677_36743 = state_36675__$1;
(statearr_36677_36743[(2)] = inst_36671);

(statearr_36677_36743[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (20))){
var state_36675__$1 = state_36675;
var statearr_36678_36744 = state_36675__$1;
(statearr_36678_36744[(2)] = null);

(statearr_36678_36744[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (1))){
var state_36675__$1 = state_36675;
var statearr_36679_36745 = state_36675__$1;
(statearr_36679_36745[(2)] = null);

(statearr_36679_36745[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (4))){
var inst_36640 = (state_36675[(7)]);
var inst_36640__$1 = (state_36675[(2)]);
var inst_36641 = (inst_36640__$1 == null);
var state_36675__$1 = (function (){var statearr_36680 = state_36675;
(statearr_36680[(7)] = inst_36640__$1);

return statearr_36680;
})();
if(cljs.core.truth_(inst_36641)){
var statearr_36681_36746 = state_36675__$1;
(statearr_36681_36746[(1)] = (5));

} else {
var statearr_36682_36747 = state_36675__$1;
(statearr_36682_36747[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (15))){
var inst_36653 = (state_36675[(8)]);
var state_36675__$1 = state_36675;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36675__$1,(18),to,inst_36653);
} else {
if((state_val_36676 === (21))){
var inst_36666 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
var statearr_36683_36748 = state_36675__$1;
(statearr_36683_36748[(2)] = inst_36666);

(statearr_36683_36748[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (13))){
var inst_36668 = (state_36675[(2)]);
var state_36675__$1 = (function (){var statearr_36684 = state_36675;
(statearr_36684[(9)] = inst_36668);

return statearr_36684;
})();
var statearr_36685_36749 = state_36675__$1;
(statearr_36685_36749[(2)] = null);

(statearr_36685_36749[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (6))){
var inst_36640 = (state_36675[(7)]);
var state_36675__$1 = state_36675;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36675__$1,(11),inst_36640);
} else {
if((state_val_36676 === (17))){
var inst_36661 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
if(cljs.core.truth_(inst_36661)){
var statearr_36686_36750 = state_36675__$1;
(statearr_36686_36750[(1)] = (19));

} else {
var statearr_36687_36751 = state_36675__$1;
(statearr_36687_36751[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (3))){
var inst_36673 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36675__$1,inst_36673);
} else {
if((state_val_36676 === (12))){
var inst_36650 = (state_36675[(10)]);
var state_36675__$1 = state_36675;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36675__$1,(14),inst_36650);
} else {
if((state_val_36676 === (2))){
var state_36675__$1 = state_36675;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36675__$1,(4),results);
} else {
if((state_val_36676 === (19))){
var state_36675__$1 = state_36675;
var statearr_36688_36752 = state_36675__$1;
(statearr_36688_36752[(2)] = null);

(statearr_36688_36752[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (11))){
var inst_36650 = (state_36675[(2)]);
var state_36675__$1 = (function (){var statearr_36689 = state_36675;
(statearr_36689[(10)] = inst_36650);

return statearr_36689;
})();
var statearr_36690_36753 = state_36675__$1;
(statearr_36690_36753[(2)] = null);

(statearr_36690_36753[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (9))){
var state_36675__$1 = state_36675;
var statearr_36691_36754 = state_36675__$1;
(statearr_36691_36754[(2)] = null);

(statearr_36691_36754[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (5))){
var state_36675__$1 = state_36675;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36692_36755 = state_36675__$1;
(statearr_36692_36755[(1)] = (8));

} else {
var statearr_36693_36756 = state_36675__$1;
(statearr_36693_36756[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (14))){
var inst_36653 = (state_36675[(8)]);
var inst_36655 = (state_36675[(11)]);
var inst_36653__$1 = (state_36675[(2)]);
var inst_36654 = (inst_36653__$1 == null);
var inst_36655__$1 = cljs.core.not(inst_36654);
var state_36675__$1 = (function (){var statearr_36694 = state_36675;
(statearr_36694[(8)] = inst_36653__$1);

(statearr_36694[(11)] = inst_36655__$1);

return statearr_36694;
})();
if(inst_36655__$1){
var statearr_36695_36757 = state_36675__$1;
(statearr_36695_36757[(1)] = (15));

} else {
var statearr_36696_36758 = state_36675__$1;
(statearr_36696_36758[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (16))){
var inst_36655 = (state_36675[(11)]);
var state_36675__$1 = state_36675;
var statearr_36697_36759 = state_36675__$1;
(statearr_36697_36759[(2)] = inst_36655);

(statearr_36697_36759[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (10))){
var inst_36647 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
var statearr_36698_36760 = state_36675__$1;
(statearr_36698_36760[(2)] = inst_36647);

(statearr_36698_36760[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (18))){
var inst_36658 = (state_36675[(2)]);
var state_36675__$1 = state_36675;
var statearr_36699_36761 = state_36675__$1;
(statearr_36699_36761[(2)] = inst_36658);

(statearr_36699_36761[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36676 === (8))){
var inst_36644 = cljs.core.async.close_BANG_(to);
var state_36675__$1 = state_36675;
var statearr_36700_36762 = state_36675__$1;
(statearr_36700_36762[(2)] = inst_36644);

(statearr_36700_36762[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto__,jobs,results,process,async))
;
return ((function (switch__36040__auto__,c__36154__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_36704 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_36704[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__);

(statearr_36704[(1)] = (1));

return statearr_36704;
});
var cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1 = (function (state_36675){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36675);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36705){if((e36705 instanceof Object)){
var ex__36044__auto__ = e36705;
var statearr_36706_36763 = state_36675;
(statearr_36706_36763[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36675);

return cljs.core.cst$kw$recur;
} else {
throw e36705;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36764 = state_36675;
state_36675 = G__36764;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__ = function(state_36675){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1.call(this,state_36675);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto__,jobs,results,process,async))
})();
var state__36156__auto__ = (function (){var statearr_36707 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36707[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto__);

return statearr_36707;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto__,jobs,results,process,async))
);

return c__36154__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args36765 = [];
var len__5740__auto___36768 = arguments.length;
var i__5741__auto___36769 = (0);
while(true){
if((i__5741__auto___36769 < len__5740__auto___36768)){
args36765.push((arguments[i__5741__auto___36769]));

var G__36770 = (i__5741__auto___36769 + (1));
i__5741__auto___36769 = G__36770;
continue;
} else {
}
break;
}

var G__36767 = args36765.length;
switch (G__36767) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36765.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,cljs.core.cst$kw$async);
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args36772 = [];
var len__5740__auto___36775 = arguments.length;
var i__5741__auto___36776 = (0);
while(true){
if((i__5741__auto___36776 < len__5740__auto___36775)){
args36772.push((arguments[i__5741__auto___36776]));

var G__36777 = (i__5741__auto___36776 + (1));
i__5741__auto___36776 = G__36777;
continue;
} else {
}
break;
}

var G__36774 = args36772.length;
switch (G__36774) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36772.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,cljs.core.cst$kw$compute);
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;
/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args36779 = [];
var len__5740__auto___36832 = arguments.length;
var i__5741__auto___36833 = (0);
while(true){
if((i__5741__auto___36833 < len__5740__auto___36832)){
args36779.push((arguments[i__5741__auto___36833]));

var G__36834 = (i__5741__auto___36833 + (1));
i__5741__auto___36833 = G__36834;
continue;
} else {
}
break;
}

var G__36781 = args36779.length;
switch (G__36781) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36779.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__36154__auto___36836 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___36836,tc,fc){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___36836,tc,fc){
return (function (state_36807){
var state_val_36808 = (state_36807[(1)]);
if((state_val_36808 === (7))){
var inst_36803 = (state_36807[(2)]);
var state_36807__$1 = state_36807;
var statearr_36809_36837 = state_36807__$1;
(statearr_36809_36837[(2)] = inst_36803);

(statearr_36809_36837[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (1))){
var state_36807__$1 = state_36807;
var statearr_36810_36838 = state_36807__$1;
(statearr_36810_36838[(2)] = null);

(statearr_36810_36838[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (4))){
var inst_36784 = (state_36807[(7)]);
var inst_36784__$1 = (state_36807[(2)]);
var inst_36785 = (inst_36784__$1 == null);
var state_36807__$1 = (function (){var statearr_36811 = state_36807;
(statearr_36811[(7)] = inst_36784__$1);

return statearr_36811;
})();
if(cljs.core.truth_(inst_36785)){
var statearr_36812_36839 = state_36807__$1;
(statearr_36812_36839[(1)] = (5));

} else {
var statearr_36813_36840 = state_36807__$1;
(statearr_36813_36840[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (13))){
var state_36807__$1 = state_36807;
var statearr_36814_36841 = state_36807__$1;
(statearr_36814_36841[(2)] = null);

(statearr_36814_36841[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (6))){
var inst_36784 = (state_36807[(7)]);
var inst_36790 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_36784) : p.call(null,inst_36784));
var state_36807__$1 = state_36807;
if(cljs.core.truth_(inst_36790)){
var statearr_36815_36842 = state_36807__$1;
(statearr_36815_36842[(1)] = (9));

} else {
var statearr_36816_36843 = state_36807__$1;
(statearr_36816_36843[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (3))){
var inst_36805 = (state_36807[(2)]);
var state_36807__$1 = state_36807;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36807__$1,inst_36805);
} else {
if((state_val_36808 === (12))){
var state_36807__$1 = state_36807;
var statearr_36817_36844 = state_36807__$1;
(statearr_36817_36844[(2)] = null);

(statearr_36817_36844[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (2))){
var state_36807__$1 = state_36807;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36807__$1,(4),ch);
} else {
if((state_val_36808 === (11))){
var inst_36784 = (state_36807[(7)]);
var inst_36794 = (state_36807[(2)]);
var state_36807__$1 = state_36807;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36807__$1,(8),inst_36794,inst_36784);
} else {
if((state_val_36808 === (9))){
var state_36807__$1 = state_36807;
var statearr_36818_36845 = state_36807__$1;
(statearr_36818_36845[(2)] = tc);

(statearr_36818_36845[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (5))){
var inst_36787 = cljs.core.async.close_BANG_(tc);
var inst_36788 = cljs.core.async.close_BANG_(fc);
var state_36807__$1 = (function (){var statearr_36819 = state_36807;
(statearr_36819[(8)] = inst_36787);

return statearr_36819;
})();
var statearr_36820_36846 = state_36807__$1;
(statearr_36820_36846[(2)] = inst_36788);

(statearr_36820_36846[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (14))){
var inst_36801 = (state_36807[(2)]);
var state_36807__$1 = state_36807;
var statearr_36821_36847 = state_36807__$1;
(statearr_36821_36847[(2)] = inst_36801);

(statearr_36821_36847[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (10))){
var state_36807__$1 = state_36807;
var statearr_36822_36848 = state_36807__$1;
(statearr_36822_36848[(2)] = fc);

(statearr_36822_36848[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36808 === (8))){
var inst_36796 = (state_36807[(2)]);
var state_36807__$1 = state_36807;
if(cljs.core.truth_(inst_36796)){
var statearr_36823_36849 = state_36807__$1;
(statearr_36823_36849[(1)] = (12));

} else {
var statearr_36824_36850 = state_36807__$1;
(statearr_36824_36850[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___36836,tc,fc))
;
return ((function (switch__36040__auto__,c__36154__auto___36836,tc,fc){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_36828 = [null,null,null,null,null,null,null,null,null];
(statearr_36828[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_36828[(1)] = (1));

return statearr_36828;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_36807){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36807);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36829){if((e36829 instanceof Object)){
var ex__36044__auto__ = e36829;
var statearr_36830_36851 = state_36807;
(statearr_36830_36851[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36807);

return cljs.core.cst$kw$recur;
} else {
throw e36829;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36852 = state_36807;
state_36807 = G__36852;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_36807){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_36807);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___36836,tc,fc))
})();
var state__36156__auto__ = (function (){var statearr_36831 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36831[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___36836);

return statearr_36831;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___36836,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__36154__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto__){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto__){
return (function (state_36916){
var state_val_36917 = (state_36916[(1)]);
if((state_val_36917 === (7))){
var inst_36912 = (state_36916[(2)]);
var state_36916__$1 = state_36916;
var statearr_36918_36939 = state_36916__$1;
(statearr_36918_36939[(2)] = inst_36912);

(statearr_36918_36939[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (1))){
var inst_36896 = init;
var state_36916__$1 = (function (){var statearr_36919 = state_36916;
(statearr_36919[(7)] = inst_36896);

return statearr_36919;
})();
var statearr_36920_36940 = state_36916__$1;
(statearr_36920_36940[(2)] = null);

(statearr_36920_36940[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (4))){
var inst_36899 = (state_36916[(8)]);
var inst_36899__$1 = (state_36916[(2)]);
var inst_36900 = (inst_36899__$1 == null);
var state_36916__$1 = (function (){var statearr_36921 = state_36916;
(statearr_36921[(8)] = inst_36899__$1);

return statearr_36921;
})();
if(cljs.core.truth_(inst_36900)){
var statearr_36922_36941 = state_36916__$1;
(statearr_36922_36941[(1)] = (5));

} else {
var statearr_36923_36942 = state_36916__$1;
(statearr_36923_36942[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (6))){
var inst_36899 = (state_36916[(8)]);
var inst_36903 = (state_36916[(9)]);
var inst_36896 = (state_36916[(7)]);
var inst_36903__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_36896,inst_36899) : f.call(null,inst_36896,inst_36899));
var inst_36904 = cljs.core.reduced_QMARK_(inst_36903__$1);
var state_36916__$1 = (function (){var statearr_36924 = state_36916;
(statearr_36924[(9)] = inst_36903__$1);

return statearr_36924;
})();
if(inst_36904){
var statearr_36925_36943 = state_36916__$1;
(statearr_36925_36943[(1)] = (8));

} else {
var statearr_36926_36944 = state_36916__$1;
(statearr_36926_36944[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (3))){
var inst_36914 = (state_36916[(2)]);
var state_36916__$1 = state_36916;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36916__$1,inst_36914);
} else {
if((state_val_36917 === (2))){
var state_36916__$1 = state_36916;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_36916__$1,(4),ch);
} else {
if((state_val_36917 === (9))){
var inst_36903 = (state_36916[(9)]);
var inst_36896 = inst_36903;
var state_36916__$1 = (function (){var statearr_36927 = state_36916;
(statearr_36927[(7)] = inst_36896);

return statearr_36927;
})();
var statearr_36928_36945 = state_36916__$1;
(statearr_36928_36945[(2)] = null);

(statearr_36928_36945[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (5))){
var inst_36896 = (state_36916[(7)]);
var state_36916__$1 = state_36916;
var statearr_36929_36946 = state_36916__$1;
(statearr_36929_36946[(2)] = inst_36896);

(statearr_36929_36946[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (10))){
var inst_36910 = (state_36916[(2)]);
var state_36916__$1 = state_36916;
var statearr_36930_36947 = state_36916__$1;
(statearr_36930_36947[(2)] = inst_36910);

(statearr_36930_36947[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36917 === (8))){
var inst_36903 = (state_36916[(9)]);
var inst_36906 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(inst_36903) : cljs.core.deref.call(null,inst_36903));
var state_36916__$1 = state_36916;
var statearr_36931_36948 = state_36916__$1;
(statearr_36931_36948[(2)] = inst_36906);

(statearr_36931_36948[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto__))
;
return ((function (switch__36040__auto__,c__36154__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__36041__auto__ = null;
var cljs$core$async$reduce_$_state_machine__36041__auto____0 = (function (){
var statearr_36935 = [null,null,null,null,null,null,null,null,null,null];
(statearr_36935[(0)] = cljs$core$async$reduce_$_state_machine__36041__auto__);

(statearr_36935[(1)] = (1));

return statearr_36935;
});
var cljs$core$async$reduce_$_state_machine__36041__auto____1 = (function (state_36916){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36916);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e36936){if((e36936 instanceof Object)){
var ex__36044__auto__ = e36936;
var statearr_36937_36949 = state_36916;
(statearr_36937_36949[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36916);

return cljs.core.cst$kw$recur;
} else {
throw e36936;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__36950 = state_36916;
state_36916 = G__36950;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__36041__auto__ = function(state_36916){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__36041__auto____1.call(this,state_36916);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__36041__auto____0;
cljs$core$async$reduce_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__36041__auto____1;
return cljs$core$async$reduce_$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto__))
})();
var state__36156__auto__ = (function (){var statearr_36938 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_36938[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto__);

return statearr_36938;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto__))
);

return c__36154__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args36951 = [];
var len__5740__auto___37003 = arguments.length;
var i__5741__auto___37004 = (0);
while(true){
if((i__5741__auto___37004 < len__5740__auto___37003)){
args36951.push((arguments[i__5741__auto___37004]));

var G__37005 = (i__5741__auto___37004 + (1));
i__5741__auto___37004 = G__37005;
continue;
} else {
}
break;
}

var G__36953 = args36951.length;
switch (G__36953) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args36951.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__36154__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto__){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto__){
return (function (state_36978){
var state_val_36979 = (state_36978[(1)]);
if((state_val_36979 === (7))){
var inst_36960 = (state_36978[(2)]);
var state_36978__$1 = state_36978;
var statearr_36980_37007 = state_36978__$1;
(statearr_36980_37007[(2)] = inst_36960);

(statearr_36980_37007[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (1))){
var inst_36954 = cljs.core.seq(coll);
var inst_36955 = inst_36954;
var state_36978__$1 = (function (){var statearr_36981 = state_36978;
(statearr_36981[(7)] = inst_36955);

return statearr_36981;
})();
var statearr_36982_37008 = state_36978__$1;
(statearr_36982_37008[(2)] = null);

(statearr_36982_37008[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (4))){
var inst_36955 = (state_36978[(7)]);
var inst_36958 = cljs.core.first(inst_36955);
var state_36978__$1 = state_36978;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_36978__$1,(7),ch,inst_36958);
} else {
if((state_val_36979 === (13))){
var inst_36972 = (state_36978[(2)]);
var state_36978__$1 = state_36978;
var statearr_36983_37009 = state_36978__$1;
(statearr_36983_37009[(2)] = inst_36972);

(statearr_36983_37009[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (6))){
var inst_36963 = (state_36978[(2)]);
var state_36978__$1 = state_36978;
if(cljs.core.truth_(inst_36963)){
var statearr_36984_37010 = state_36978__$1;
(statearr_36984_37010[(1)] = (8));

} else {
var statearr_36985_37011 = state_36978__$1;
(statearr_36985_37011[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (3))){
var inst_36976 = (state_36978[(2)]);
var state_36978__$1 = state_36978;
return cljs.core.async.impl.ioc_helpers.return_chan(state_36978__$1,inst_36976);
} else {
if((state_val_36979 === (12))){
var state_36978__$1 = state_36978;
var statearr_36986_37012 = state_36978__$1;
(statearr_36986_37012[(2)] = null);

(statearr_36986_37012[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (2))){
var inst_36955 = (state_36978[(7)]);
var state_36978__$1 = state_36978;
if(cljs.core.truth_(inst_36955)){
var statearr_36987_37013 = state_36978__$1;
(statearr_36987_37013[(1)] = (4));

} else {
var statearr_36988_37014 = state_36978__$1;
(statearr_36988_37014[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (11))){
var inst_36969 = cljs.core.async.close_BANG_(ch);
var state_36978__$1 = state_36978;
var statearr_36989_37015 = state_36978__$1;
(statearr_36989_37015[(2)] = inst_36969);

(statearr_36989_37015[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (9))){
var state_36978__$1 = state_36978;
if(cljs.core.truth_(close_QMARK_)){
var statearr_36990_37016 = state_36978__$1;
(statearr_36990_37016[(1)] = (11));

} else {
var statearr_36991_37017 = state_36978__$1;
(statearr_36991_37017[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (5))){
var inst_36955 = (state_36978[(7)]);
var state_36978__$1 = state_36978;
var statearr_36992_37018 = state_36978__$1;
(statearr_36992_37018[(2)] = inst_36955);

(statearr_36992_37018[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (10))){
var inst_36974 = (state_36978[(2)]);
var state_36978__$1 = state_36978;
var statearr_36993_37019 = state_36978__$1;
(statearr_36993_37019[(2)] = inst_36974);

(statearr_36993_37019[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_36979 === (8))){
var inst_36955 = (state_36978[(7)]);
var inst_36965 = cljs.core.next(inst_36955);
var inst_36955__$1 = inst_36965;
var state_36978__$1 = (function (){var statearr_36994 = state_36978;
(statearr_36994[(7)] = inst_36955__$1);

return statearr_36994;
})();
var statearr_36995_37020 = state_36978__$1;
(statearr_36995_37020[(2)] = null);

(statearr_36995_37020[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto__))
;
return ((function (switch__36040__auto__,c__36154__auto__){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_36999 = [null,null,null,null,null,null,null,null];
(statearr_36999[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_36999[(1)] = (1));

return statearr_36999;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_36978){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_36978);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e37000){if((e37000 instanceof Object)){
var ex__36044__auto__ = e37000;
var statearr_37001_37021 = state_36978;
(statearr_37001_37021[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_36978);

return cljs.core.cst$kw$recur;
} else {
throw e37000;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__37022 = state_36978;
state_36978 = G__37022;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_36978){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_36978);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto__))
})();
var state__36156__auto__ = (function (){var statearr_37002 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_37002[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto__);

return statearr_37002;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto__))
);

return c__36154__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__5337__auto__ = (((_ == null))?null:_);
var m__5338__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__5338__auto__.call(null,_));
} else {
var m__5338__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(_) : m__5338__auto____$1.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5338__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__5338__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__5338__auto____$1.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto__.call(null,m));
} else {
var m__5338__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = (function (){var G__37247 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37247) : cljs.core.atom.call(null,G__37247));
})();
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async37248 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37248 = (function (mult,ch,cs,meta37249){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta37249 = meta37249;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_37250,meta37249__$1){
var self__ = this;
var _37250__$1 = this;
return (new cljs.core.async.t_cljs$core$async37248(self__.mult,self__.ch,self__.cs,meta37249__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_37250){
var self__ = this;
var _37250__$1 = this;
return self__.meta37249;
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37251_37471 = self__.cs;
var G__37252_37472 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37251_37471,G__37252_37472) : cljs.core.reset_BANG_.call(null,G__37251_37471,G__37252_37472));

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$mult,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),cljs.core.cst$sym$ch,cljs.core.cst$sym$cs,cljs.core.cst$sym$meta37249], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async37248.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37248.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37248";

cljs.core.async.t_cljs$core$async37248.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37248");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async37248 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async37248(mult__$1,ch__$1,cs__$1,meta37249){
return (new cljs.core.async.t_cljs$core$async37248(mult__$1,ch__$1,cs__$1,meta37249));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async37248(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__36154__auto___37473 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___37473,cs,m,dchan,dctr,done){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___37473,cs,m,dchan,dctr,done){
return (function (state_37383){
var state_val_37384 = (state_37383[(1)]);
if((state_val_37384 === (7))){
var inst_37379 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37385_37474 = state_37383__$1;
(statearr_37385_37474[(2)] = inst_37379);

(statearr_37385_37474[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (20))){
var inst_37284 = (state_37383[(7)]);
var inst_37294 = cljs.core.first(inst_37284);
var inst_37295 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37294,(0),null);
var inst_37296 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37294,(1),null);
var state_37383__$1 = (function (){var statearr_37386 = state_37383;
(statearr_37386[(8)] = inst_37295);

return statearr_37386;
})();
if(cljs.core.truth_(inst_37296)){
var statearr_37387_37475 = state_37383__$1;
(statearr_37387_37475[(1)] = (22));

} else {
var statearr_37388_37476 = state_37383__$1;
(statearr_37388_37476[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (27))){
var inst_37331 = (state_37383[(9)]);
var inst_37324 = (state_37383[(10)]);
var inst_37255 = (state_37383[(11)]);
var inst_37326 = (state_37383[(12)]);
var inst_37331__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37324,inst_37326);
var inst_37332 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_37331__$1,inst_37255,done);
var state_37383__$1 = (function (){var statearr_37389 = state_37383;
(statearr_37389[(9)] = inst_37331__$1);

return statearr_37389;
})();
if(cljs.core.truth_(inst_37332)){
var statearr_37390_37477 = state_37383__$1;
(statearr_37390_37477[(1)] = (30));

} else {
var statearr_37391_37478 = state_37383__$1;
(statearr_37391_37478[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (1))){
var state_37383__$1 = state_37383;
var statearr_37392_37479 = state_37383__$1;
(statearr_37392_37479[(2)] = null);

(statearr_37392_37479[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (24))){
var inst_37284 = (state_37383[(7)]);
var inst_37301 = (state_37383[(2)]);
var inst_37302 = cljs.core.next(inst_37284);
var inst_37264 = inst_37302;
var inst_37265 = null;
var inst_37266 = (0);
var inst_37267 = (0);
var state_37383__$1 = (function (){var statearr_37393 = state_37383;
(statearr_37393[(13)] = inst_37264);

(statearr_37393[(14)] = inst_37266);

(statearr_37393[(15)] = inst_37265);

(statearr_37393[(16)] = inst_37267);

(statearr_37393[(17)] = inst_37301);

return statearr_37393;
})();
var statearr_37394_37480 = state_37383__$1;
(statearr_37394_37480[(2)] = null);

(statearr_37394_37480[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (39))){
var state_37383__$1 = state_37383;
var statearr_37398_37481 = state_37383__$1;
(statearr_37398_37481[(2)] = null);

(statearr_37398_37481[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (4))){
var inst_37255 = (state_37383[(11)]);
var inst_37255__$1 = (state_37383[(2)]);
var inst_37256 = (inst_37255__$1 == null);
var state_37383__$1 = (function (){var statearr_37399 = state_37383;
(statearr_37399[(11)] = inst_37255__$1);

return statearr_37399;
})();
if(cljs.core.truth_(inst_37256)){
var statearr_37400_37482 = state_37383__$1;
(statearr_37400_37482[(1)] = (5));

} else {
var statearr_37401_37483 = state_37383__$1;
(statearr_37401_37483[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (15))){
var inst_37264 = (state_37383[(13)]);
var inst_37266 = (state_37383[(14)]);
var inst_37265 = (state_37383[(15)]);
var inst_37267 = (state_37383[(16)]);
var inst_37280 = (state_37383[(2)]);
var inst_37281 = (inst_37267 + (1));
var tmp37395 = inst_37264;
var tmp37396 = inst_37266;
var tmp37397 = inst_37265;
var inst_37264__$1 = tmp37395;
var inst_37265__$1 = tmp37397;
var inst_37266__$1 = tmp37396;
var inst_37267__$1 = inst_37281;
var state_37383__$1 = (function (){var statearr_37402 = state_37383;
(statearr_37402[(13)] = inst_37264__$1);

(statearr_37402[(14)] = inst_37266__$1);

(statearr_37402[(15)] = inst_37265__$1);

(statearr_37402[(16)] = inst_37267__$1);

(statearr_37402[(18)] = inst_37280);

return statearr_37402;
})();
var statearr_37403_37484 = state_37383__$1;
(statearr_37403_37484[(2)] = null);

(statearr_37403_37484[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (21))){
var inst_37305 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37407_37485 = state_37383__$1;
(statearr_37407_37485[(2)] = inst_37305);

(statearr_37407_37485[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (31))){
var inst_37331 = (state_37383[(9)]);
var inst_37335 = done(null);
var inst_37336 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_37331);
var state_37383__$1 = (function (){var statearr_37408 = state_37383;
(statearr_37408[(19)] = inst_37335);

return statearr_37408;
})();
var statearr_37409_37486 = state_37383__$1;
(statearr_37409_37486[(2)] = inst_37336);

(statearr_37409_37486[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (32))){
var inst_37323 = (state_37383[(20)]);
var inst_37325 = (state_37383[(21)]);
var inst_37324 = (state_37383[(10)]);
var inst_37326 = (state_37383[(12)]);
var inst_37338 = (state_37383[(2)]);
var inst_37339 = (inst_37326 + (1));
var tmp37404 = inst_37323;
var tmp37405 = inst_37325;
var tmp37406 = inst_37324;
var inst_37323__$1 = tmp37404;
var inst_37324__$1 = tmp37406;
var inst_37325__$1 = tmp37405;
var inst_37326__$1 = inst_37339;
var state_37383__$1 = (function (){var statearr_37410 = state_37383;
(statearr_37410[(20)] = inst_37323__$1);

(statearr_37410[(21)] = inst_37325__$1);

(statearr_37410[(10)] = inst_37324__$1);

(statearr_37410[(12)] = inst_37326__$1);

(statearr_37410[(22)] = inst_37338);

return statearr_37410;
})();
var statearr_37411_37487 = state_37383__$1;
(statearr_37411_37487[(2)] = null);

(statearr_37411_37487[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (40))){
var inst_37351 = (state_37383[(23)]);
var inst_37355 = done(null);
var inst_37356 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_37351);
var state_37383__$1 = (function (){var statearr_37412 = state_37383;
(statearr_37412[(24)] = inst_37355);

return statearr_37412;
})();
var statearr_37413_37488 = state_37383__$1;
(statearr_37413_37488[(2)] = inst_37356);

(statearr_37413_37488[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (33))){
var inst_37342 = (state_37383[(25)]);
var inst_37344 = cljs.core.chunked_seq_QMARK_(inst_37342);
var state_37383__$1 = state_37383;
if(inst_37344){
var statearr_37414_37489 = state_37383__$1;
(statearr_37414_37489[(1)] = (36));

} else {
var statearr_37415_37490 = state_37383__$1;
(statearr_37415_37490[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (13))){
var inst_37274 = (state_37383[(26)]);
var inst_37277 = cljs.core.async.close_BANG_(inst_37274);
var state_37383__$1 = state_37383;
var statearr_37416_37491 = state_37383__$1;
(statearr_37416_37491[(2)] = inst_37277);

(statearr_37416_37491[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (22))){
var inst_37295 = (state_37383[(8)]);
var inst_37298 = cljs.core.async.close_BANG_(inst_37295);
var state_37383__$1 = state_37383;
var statearr_37417_37492 = state_37383__$1;
(statearr_37417_37492[(2)] = inst_37298);

(statearr_37417_37492[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (36))){
var inst_37342 = (state_37383[(25)]);
var inst_37346 = cljs.core.chunk_first(inst_37342);
var inst_37347 = cljs.core.chunk_rest(inst_37342);
var inst_37348 = cljs.core.count(inst_37346);
var inst_37323 = inst_37347;
var inst_37324 = inst_37346;
var inst_37325 = inst_37348;
var inst_37326 = (0);
var state_37383__$1 = (function (){var statearr_37418 = state_37383;
(statearr_37418[(20)] = inst_37323);

(statearr_37418[(21)] = inst_37325);

(statearr_37418[(10)] = inst_37324);

(statearr_37418[(12)] = inst_37326);

return statearr_37418;
})();
var statearr_37419_37493 = state_37383__$1;
(statearr_37419_37493[(2)] = null);

(statearr_37419_37493[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (41))){
var inst_37342 = (state_37383[(25)]);
var inst_37358 = (state_37383[(2)]);
var inst_37359 = cljs.core.next(inst_37342);
var inst_37323 = inst_37359;
var inst_37324 = null;
var inst_37325 = (0);
var inst_37326 = (0);
var state_37383__$1 = (function (){var statearr_37420 = state_37383;
(statearr_37420[(20)] = inst_37323);

(statearr_37420[(21)] = inst_37325);

(statearr_37420[(27)] = inst_37358);

(statearr_37420[(10)] = inst_37324);

(statearr_37420[(12)] = inst_37326);

return statearr_37420;
})();
var statearr_37421_37494 = state_37383__$1;
(statearr_37421_37494[(2)] = null);

(statearr_37421_37494[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (43))){
var state_37383__$1 = state_37383;
var statearr_37422_37495 = state_37383__$1;
(statearr_37422_37495[(2)] = null);

(statearr_37422_37495[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (29))){
var inst_37367 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37423_37496 = state_37383__$1;
(statearr_37423_37496[(2)] = inst_37367);

(statearr_37423_37496[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (44))){
var inst_37376 = (state_37383[(2)]);
var state_37383__$1 = (function (){var statearr_37424 = state_37383;
(statearr_37424[(28)] = inst_37376);

return statearr_37424;
})();
var statearr_37425_37497 = state_37383__$1;
(statearr_37425_37497[(2)] = null);

(statearr_37425_37497[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (6))){
var inst_37315 = (state_37383[(29)]);
var inst_37314 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_37315__$1 = cljs.core.keys(inst_37314);
var inst_37316 = cljs.core.count(inst_37315__$1);
var inst_37317 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,inst_37316) : cljs.core.reset_BANG_.call(null,dctr,inst_37316));
var inst_37322 = cljs.core.seq(inst_37315__$1);
var inst_37323 = inst_37322;
var inst_37324 = null;
var inst_37325 = (0);
var inst_37326 = (0);
var state_37383__$1 = (function (){var statearr_37426 = state_37383;
(statearr_37426[(29)] = inst_37315__$1);

(statearr_37426[(20)] = inst_37323);

(statearr_37426[(21)] = inst_37325);

(statearr_37426[(30)] = inst_37317);

(statearr_37426[(10)] = inst_37324);

(statearr_37426[(12)] = inst_37326);

return statearr_37426;
})();
var statearr_37427_37498 = state_37383__$1;
(statearr_37427_37498[(2)] = null);

(statearr_37427_37498[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (28))){
var inst_37323 = (state_37383[(20)]);
var inst_37342 = (state_37383[(25)]);
var inst_37342__$1 = cljs.core.seq(inst_37323);
var state_37383__$1 = (function (){var statearr_37428 = state_37383;
(statearr_37428[(25)] = inst_37342__$1);

return statearr_37428;
})();
if(inst_37342__$1){
var statearr_37429_37499 = state_37383__$1;
(statearr_37429_37499[(1)] = (33));

} else {
var statearr_37430_37500 = state_37383__$1;
(statearr_37430_37500[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (25))){
var inst_37325 = (state_37383[(21)]);
var inst_37326 = (state_37383[(12)]);
var inst_37328 = (inst_37326 < inst_37325);
var inst_37329 = inst_37328;
var state_37383__$1 = state_37383;
if(cljs.core.truth_(inst_37329)){
var statearr_37431_37501 = state_37383__$1;
(statearr_37431_37501[(1)] = (27));

} else {
var statearr_37432_37502 = state_37383__$1;
(statearr_37432_37502[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (34))){
var state_37383__$1 = state_37383;
var statearr_37433_37503 = state_37383__$1;
(statearr_37433_37503[(2)] = null);

(statearr_37433_37503[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (17))){
var state_37383__$1 = state_37383;
var statearr_37434_37504 = state_37383__$1;
(statearr_37434_37504[(2)] = null);

(statearr_37434_37504[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (3))){
var inst_37381 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37383__$1,inst_37381);
} else {
if((state_val_37384 === (12))){
var inst_37310 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37435_37505 = state_37383__$1;
(statearr_37435_37505[(2)] = inst_37310);

(statearr_37435_37505[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (2))){
var state_37383__$1 = state_37383;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37383__$1,(4),ch);
} else {
if((state_val_37384 === (23))){
var state_37383__$1 = state_37383;
var statearr_37436_37506 = state_37383__$1;
(statearr_37436_37506[(2)] = null);

(statearr_37436_37506[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (35))){
var inst_37365 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37437_37507 = state_37383__$1;
(statearr_37437_37507[(2)] = inst_37365);

(statearr_37437_37507[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (19))){
var inst_37284 = (state_37383[(7)]);
var inst_37288 = cljs.core.chunk_first(inst_37284);
var inst_37289 = cljs.core.chunk_rest(inst_37284);
var inst_37290 = cljs.core.count(inst_37288);
var inst_37264 = inst_37289;
var inst_37265 = inst_37288;
var inst_37266 = inst_37290;
var inst_37267 = (0);
var state_37383__$1 = (function (){var statearr_37438 = state_37383;
(statearr_37438[(13)] = inst_37264);

(statearr_37438[(14)] = inst_37266);

(statearr_37438[(15)] = inst_37265);

(statearr_37438[(16)] = inst_37267);

return statearr_37438;
})();
var statearr_37439_37508 = state_37383__$1;
(statearr_37439_37508[(2)] = null);

(statearr_37439_37508[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (11))){
var inst_37264 = (state_37383[(13)]);
var inst_37284 = (state_37383[(7)]);
var inst_37284__$1 = cljs.core.seq(inst_37264);
var state_37383__$1 = (function (){var statearr_37440 = state_37383;
(statearr_37440[(7)] = inst_37284__$1);

return statearr_37440;
})();
if(inst_37284__$1){
var statearr_37441_37509 = state_37383__$1;
(statearr_37441_37509[(1)] = (16));

} else {
var statearr_37442_37510 = state_37383__$1;
(statearr_37442_37510[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (9))){
var inst_37312 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37443_37511 = state_37383__$1;
(statearr_37443_37511[(2)] = inst_37312);

(statearr_37443_37511[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (5))){
var inst_37262 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_37263 = cljs.core.seq(inst_37262);
var inst_37264 = inst_37263;
var inst_37265 = null;
var inst_37266 = (0);
var inst_37267 = (0);
var state_37383__$1 = (function (){var statearr_37444 = state_37383;
(statearr_37444[(13)] = inst_37264);

(statearr_37444[(14)] = inst_37266);

(statearr_37444[(15)] = inst_37265);

(statearr_37444[(16)] = inst_37267);

return statearr_37444;
})();
var statearr_37445_37512 = state_37383__$1;
(statearr_37445_37512[(2)] = null);

(statearr_37445_37512[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (14))){
var state_37383__$1 = state_37383;
var statearr_37446_37513 = state_37383__$1;
(statearr_37446_37513[(2)] = null);

(statearr_37446_37513[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (45))){
var inst_37373 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37447_37514 = state_37383__$1;
(statearr_37447_37514[(2)] = inst_37373);

(statearr_37447_37514[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (26))){
var inst_37315 = (state_37383[(29)]);
var inst_37369 = (state_37383[(2)]);
var inst_37370 = cljs.core.seq(inst_37315);
var state_37383__$1 = (function (){var statearr_37448 = state_37383;
(statearr_37448[(31)] = inst_37369);

return statearr_37448;
})();
if(inst_37370){
var statearr_37449_37515 = state_37383__$1;
(statearr_37449_37515[(1)] = (42));

} else {
var statearr_37450_37516 = state_37383__$1;
(statearr_37450_37516[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (16))){
var inst_37284 = (state_37383[(7)]);
var inst_37286 = cljs.core.chunked_seq_QMARK_(inst_37284);
var state_37383__$1 = state_37383;
if(inst_37286){
var statearr_37451_37517 = state_37383__$1;
(statearr_37451_37517[(1)] = (19));

} else {
var statearr_37452_37518 = state_37383__$1;
(statearr_37452_37518[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (38))){
var inst_37362 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37453_37519 = state_37383__$1;
(statearr_37453_37519[(2)] = inst_37362);

(statearr_37453_37519[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (30))){
var state_37383__$1 = state_37383;
var statearr_37454_37520 = state_37383__$1;
(statearr_37454_37520[(2)] = null);

(statearr_37454_37520[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (10))){
var inst_37265 = (state_37383[(15)]);
var inst_37267 = (state_37383[(16)]);
var inst_37273 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37265,inst_37267);
var inst_37274 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37273,(0),null);
var inst_37275 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37273,(1),null);
var state_37383__$1 = (function (){var statearr_37455 = state_37383;
(statearr_37455[(26)] = inst_37274);

return statearr_37455;
})();
if(cljs.core.truth_(inst_37275)){
var statearr_37456_37521 = state_37383__$1;
(statearr_37456_37521[(1)] = (13));

} else {
var statearr_37457_37522 = state_37383__$1;
(statearr_37457_37522[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (18))){
var inst_37308 = (state_37383[(2)]);
var state_37383__$1 = state_37383;
var statearr_37458_37523 = state_37383__$1;
(statearr_37458_37523[(2)] = inst_37308);

(statearr_37458_37523[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (42))){
var state_37383__$1 = state_37383;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_37383__$1,(45),dchan);
} else {
if((state_val_37384 === (37))){
var inst_37351 = (state_37383[(23)]);
var inst_37255 = (state_37383[(11)]);
var inst_37342 = (state_37383[(25)]);
var inst_37351__$1 = cljs.core.first(inst_37342);
var inst_37352 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_37351__$1,inst_37255,done);
var state_37383__$1 = (function (){var statearr_37459 = state_37383;
(statearr_37459[(23)] = inst_37351__$1);

return statearr_37459;
})();
if(cljs.core.truth_(inst_37352)){
var statearr_37460_37524 = state_37383__$1;
(statearr_37460_37524[(1)] = (39));

} else {
var statearr_37461_37525 = state_37383__$1;
(statearr_37461_37525[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37384 === (8))){
var inst_37266 = (state_37383[(14)]);
var inst_37267 = (state_37383[(16)]);
var inst_37269 = (inst_37267 < inst_37266);
var inst_37270 = inst_37269;
var state_37383__$1 = state_37383;
if(cljs.core.truth_(inst_37270)){
var statearr_37462_37526 = state_37383__$1;
(statearr_37462_37526[(1)] = (10));

} else {
var statearr_37463_37527 = state_37383__$1;
(statearr_37463_37527[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___37473,cs,m,dchan,dctr,done))
;
return ((function (switch__36040__auto__,c__36154__auto___37473,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__36041__auto__ = null;
var cljs$core$async$mult_$_state_machine__36041__auto____0 = (function (){
var statearr_37467 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37467[(0)] = cljs$core$async$mult_$_state_machine__36041__auto__);

(statearr_37467[(1)] = (1));

return statearr_37467;
});
var cljs$core$async$mult_$_state_machine__36041__auto____1 = (function (state_37383){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_37383);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e37468){if((e37468 instanceof Object)){
var ex__36044__auto__ = e37468;
var statearr_37469_37528 = state_37383;
(statearr_37469_37528[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37383);

return cljs.core.cst$kw$recur;
} else {
throw e37468;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__37529 = state_37383;
state_37383 = G__37529;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__36041__auto__ = function(state_37383){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__36041__auto____1.call(this,state_37383);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__36041__auto____0;
cljs$core$async$mult_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__36041__auto____1;
return cljs$core$async$mult_$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___37473,cs,m,dchan,dctr,done))
})();
var state__36156__auto__ = (function (){var statearr_37470 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_37470[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___37473);

return statearr_37470;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___37473,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args37530 = [];
var len__5740__auto___37533 = arguments.length;
var i__5741__auto___37534 = (0);
while(true){
if((i__5741__auto___37534 < len__5740__auto___37533)){
args37530.push((arguments[i__5741__auto___37534]));

var G__37535 = (i__5741__auto___37534 + (1));
i__5741__auto___37534 = G__37535;
continue;
} else {
}
break;
}

var G__37532 = args37530.length;
switch (G__37532) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37530.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto__.call(null,m,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__5338__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto__.call(null,m));
} else {
var m__5338__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__5338__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5338__auto__.call(null,m,state_map));
} else {
var m__5338__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__5338__auto____$1.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__5337__auto__ = (((m == null))?null:m);
var m__5338__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5338__auto__.call(null,m,mode));
} else {
var m__5338__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(m,mode) : m__5338__auto____$1.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__5747__auto__ = [];
var len__5740__auto___37547 = arguments.length;
var i__5741__auto___37548 = (0);
while(true){
if((i__5741__auto___37548 < len__5740__auto___37547)){
args__5747__auto__.push((arguments[i__5741__auto___37548]));

var G__37549 = (i__5741__auto___37548 + (1));
i__5741__auto___37548 = G__37549;
continue;
} else {
}
break;
}

var argseq__5748__auto__ = ((((3) < args__5747__auto__.length))?(new cljs.core.IndexedSeq(args__5747__auto__.slice((3)),(0))):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5748__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__37541){
var map__37542 = p__37541;
var map__37542__$1 = ((((!((map__37542 == null)))?((((map__37542.cljs$lang$protocol_mask$partition0$ & (64))) || (map__37542.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__37542):map__37542);
var opts = map__37542__$1;
var statearr_37544_37550 = state;
(statearr_37544_37550[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4653__auto__ = cljs.core.async.do_alts(((function (map__37542,map__37542__$1,opts){
return (function (val){
var statearr_37545_37551 = state;
(statearr_37545_37551[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
});})(map__37542,map__37542__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4653__auto__)){
var cb = temp__4653__auto__;
var statearr_37546_37552 = state;
(statearr_37546_37552[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cb) : cljs.core.deref.call(null,cb)));


return cljs.core.cst$kw$recur;
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq37537){
var G__37538 = cljs.core.first(seq37537);
var seq37537__$1 = cljs.core.next(seq37537);
var G__37539 = cljs.core.first(seq37537__$1);
var seq37537__$2 = cljs.core.next(seq37537__$1);
var G__37540 = cljs.core.first(seq37537__$2);
var seq37537__$3 = cljs.core.next(seq37537__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__37538,G__37539,G__37540,seq37537__$3);
});
/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = (function (){var G__37719 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37719) : cljs.core.atom.call(null,G__37719));
})();
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$pause,null,cljs.core.cst$kw$mute,null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,cljs.core.cst$kw$solo);
var solo_mode = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$mute) : cljs.core.atom.call(null,cljs.core.cst$kw$mute));
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var mode = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(solo_mode) : cljs.core.deref.call(null,solo_mode));
var solos = pick(cljs.core.cst$kw$solo,chs);
var pauses = pick(cljs.core.cst$kw$pause,chs);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$solos,solos,cljs.core.cst$kw$mutes,pick(cljs.core.cst$kw$mute,chs),cljs.core.cst$kw$reads,cljs.core.conj.cljs$core$IFn$_invoke$arity$2((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,cljs.core.cst$kw$pause)) && (!(cljs.core.empty_QMARK_(solos))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async37720 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37720 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta37721){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta37721 = meta37721;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_37722,meta37721__$1){
var self__ = this;
var _37722__$1 = this;
return (new cljs.core.async.t_cljs$core$async37720(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta37721__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_37722){
var self__ = this;
var _37722__$1 = this;
return self__.meta37721;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37723_37885 = self__.cs;
var G__37724_37886 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37723_37885,G__37724_37886) : cljs.core.reset_BANG_.call(null,G__37723_37885,G__37724_37886));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([cljs.core.list(cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$mode)], 0)))].join('')));
}

(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.solo_mode,mode) : cljs.core.reset_BANG_.call(null,self__.solo_mode,mode));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$change,cljs.core.with_meta(cljs.core.cst$sym$mix,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$out], null))),cljs.core.cst$kw$doc,"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),cljs.core.cst$sym$solo_DASH_mode,cljs.core.cst$sym$pick,cljs.core.cst$sym$cs,cljs.core.cst$sym$calc_DASH_state,cljs.core.cst$sym$out,cljs.core.cst$sym$changed,cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$attrs,cljs.core.cst$sym$meta37721], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async37720.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37720.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37720";

cljs.core.async.t_cljs$core$async37720.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37720");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async37720 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async37720(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta37721){
return (new cljs.core.async.t_cljs$core$async37720(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta37721));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async37720(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__36154__auto___37887 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_37822){
var state_val_37823 = (state_37822[(1)]);
if((state_val_37823 === (7))){
var inst_37740 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
var statearr_37824_37888 = state_37822__$1;
(statearr_37824_37888[(2)] = inst_37740);

(statearr_37824_37888[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (20))){
var inst_37752 = (state_37822[(7)]);
var state_37822__$1 = state_37822;
var statearr_37825_37889 = state_37822__$1;
(statearr_37825_37889[(2)] = inst_37752);

(statearr_37825_37889[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (27))){
var state_37822__$1 = state_37822;
var statearr_37826_37890 = state_37822__$1;
(statearr_37826_37890[(2)] = null);

(statearr_37826_37890[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (1))){
var inst_37728 = (state_37822[(8)]);
var inst_37728__$1 = calc_state();
var inst_37730 = (inst_37728__$1 == null);
var inst_37731 = cljs.core.not(inst_37730);
var state_37822__$1 = (function (){var statearr_37827 = state_37822;
(statearr_37827[(8)] = inst_37728__$1);

return statearr_37827;
})();
if(inst_37731){
var statearr_37828_37891 = state_37822__$1;
(statearr_37828_37891[(1)] = (2));

} else {
var statearr_37829_37892 = state_37822__$1;
(statearr_37829_37892[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (24))){
var inst_37782 = (state_37822[(9)]);
var inst_37796 = (state_37822[(10)]);
var inst_37775 = (state_37822[(11)]);
var inst_37796__$1 = (inst_37775.cljs$core$IFn$_invoke$arity$1 ? inst_37775.cljs$core$IFn$_invoke$arity$1(inst_37782) : inst_37775.call(null,inst_37782));
var state_37822__$1 = (function (){var statearr_37830 = state_37822;
(statearr_37830[(10)] = inst_37796__$1);

return statearr_37830;
})();
if(cljs.core.truth_(inst_37796__$1)){
var statearr_37831_37893 = state_37822__$1;
(statearr_37831_37893[(1)] = (29));

} else {
var statearr_37832_37894 = state_37822__$1;
(statearr_37832_37894[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (4))){
var inst_37743 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37743)){
var statearr_37833_37895 = state_37822__$1;
(statearr_37833_37895[(1)] = (8));

} else {
var statearr_37834_37896 = state_37822__$1;
(statearr_37834_37896[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (15))){
var inst_37769 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37769)){
var statearr_37835_37897 = state_37822__$1;
(statearr_37835_37897[(1)] = (19));

} else {
var statearr_37836_37898 = state_37822__$1;
(statearr_37836_37898[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (21))){
var inst_37774 = (state_37822[(12)]);
var inst_37774__$1 = (state_37822[(2)]);
var inst_37775 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37774__$1,cljs.core.cst$kw$solos);
var inst_37776 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37774__$1,cljs.core.cst$kw$mutes);
var inst_37777 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37774__$1,cljs.core.cst$kw$reads);
var state_37822__$1 = (function (){var statearr_37837 = state_37822;
(statearr_37837[(11)] = inst_37775);

(statearr_37837[(13)] = inst_37776);

(statearr_37837[(12)] = inst_37774__$1);

return statearr_37837;
})();
return cljs.core.async.ioc_alts_BANG_(state_37822__$1,(22),inst_37777);
} else {
if((state_val_37823 === (31))){
var inst_37804 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37804)){
var statearr_37838_37899 = state_37822__$1;
(statearr_37838_37899[(1)] = (32));

} else {
var statearr_37839_37900 = state_37822__$1;
(statearr_37839_37900[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (32))){
var inst_37781 = (state_37822[(14)]);
var state_37822__$1 = state_37822;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_37822__$1,(35),out,inst_37781);
} else {
if((state_val_37823 === (33))){
var inst_37774 = (state_37822[(12)]);
var inst_37752 = inst_37774;
var state_37822__$1 = (function (){var statearr_37840 = state_37822;
(statearr_37840[(7)] = inst_37752);

return statearr_37840;
})();
var statearr_37841_37901 = state_37822__$1;
(statearr_37841_37901[(2)] = null);

(statearr_37841_37901[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (13))){
var inst_37752 = (state_37822[(7)]);
var inst_37759 = inst_37752.cljs$lang$protocol_mask$partition0$;
var inst_37760 = (inst_37759 & (64));
var inst_37761 = inst_37752.cljs$core$ISeq$;
var inst_37762 = (inst_37760) || (inst_37761);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37762)){
var statearr_37842_37902 = state_37822__$1;
(statearr_37842_37902[(1)] = (16));

} else {
var statearr_37843_37903 = state_37822__$1;
(statearr_37843_37903[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (22))){
var inst_37781 = (state_37822[(14)]);
var inst_37782 = (state_37822[(9)]);
var inst_37780 = (state_37822[(2)]);
var inst_37781__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37780,(0),null);
var inst_37782__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_37780,(1),null);
var inst_37783 = (inst_37781__$1 == null);
var inst_37784 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_37782__$1,change);
var inst_37785 = (inst_37783) || (inst_37784);
var state_37822__$1 = (function (){var statearr_37844 = state_37822;
(statearr_37844[(14)] = inst_37781__$1);

(statearr_37844[(9)] = inst_37782__$1);

return statearr_37844;
})();
if(cljs.core.truth_(inst_37785)){
var statearr_37845_37904 = state_37822__$1;
(statearr_37845_37904[(1)] = (23));

} else {
var statearr_37846_37905 = state_37822__$1;
(statearr_37846_37905[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (36))){
var inst_37774 = (state_37822[(12)]);
var inst_37752 = inst_37774;
var state_37822__$1 = (function (){var statearr_37847 = state_37822;
(statearr_37847[(7)] = inst_37752);

return statearr_37847;
})();
var statearr_37848_37906 = state_37822__$1;
(statearr_37848_37906[(2)] = null);

(statearr_37848_37906[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (29))){
var inst_37796 = (state_37822[(10)]);
var state_37822__$1 = state_37822;
var statearr_37849_37907 = state_37822__$1;
(statearr_37849_37907[(2)] = inst_37796);

(statearr_37849_37907[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (6))){
var state_37822__$1 = state_37822;
var statearr_37850_37908 = state_37822__$1;
(statearr_37850_37908[(2)] = false);

(statearr_37850_37908[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (28))){
var inst_37792 = (state_37822[(2)]);
var inst_37793 = calc_state();
var inst_37752 = inst_37793;
var state_37822__$1 = (function (){var statearr_37851 = state_37822;
(statearr_37851[(7)] = inst_37752);

(statearr_37851[(15)] = inst_37792);

return statearr_37851;
})();
var statearr_37852_37909 = state_37822__$1;
(statearr_37852_37909[(2)] = null);

(statearr_37852_37909[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (25))){
var inst_37818 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
var statearr_37853_37910 = state_37822__$1;
(statearr_37853_37910[(2)] = inst_37818);

(statearr_37853_37910[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (34))){
var inst_37816 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
var statearr_37854_37911 = state_37822__$1;
(statearr_37854_37911[(2)] = inst_37816);

(statearr_37854_37911[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (17))){
var state_37822__$1 = state_37822;
var statearr_37855_37912 = state_37822__$1;
(statearr_37855_37912[(2)] = false);

(statearr_37855_37912[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (3))){
var state_37822__$1 = state_37822;
var statearr_37856_37913 = state_37822__$1;
(statearr_37856_37913[(2)] = false);

(statearr_37856_37913[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (12))){
var inst_37820 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
return cljs.core.async.impl.ioc_helpers.return_chan(state_37822__$1,inst_37820);
} else {
if((state_val_37823 === (2))){
var inst_37728 = (state_37822[(8)]);
var inst_37733 = inst_37728.cljs$lang$protocol_mask$partition0$;
var inst_37734 = (inst_37733 & (64));
var inst_37735 = inst_37728.cljs$core$ISeq$;
var inst_37736 = (inst_37734) || (inst_37735);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37736)){
var statearr_37857_37914 = state_37822__$1;
(statearr_37857_37914[(1)] = (5));

} else {
var statearr_37858_37915 = state_37822__$1;
(statearr_37858_37915[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (23))){
var inst_37781 = (state_37822[(14)]);
var inst_37787 = (inst_37781 == null);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37787)){
var statearr_37859_37916 = state_37822__$1;
(statearr_37859_37916[(1)] = (26));

} else {
var statearr_37860_37917 = state_37822__$1;
(statearr_37860_37917[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (35))){
var inst_37807 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
if(cljs.core.truth_(inst_37807)){
var statearr_37861_37918 = state_37822__$1;
(statearr_37861_37918[(1)] = (36));

} else {
var statearr_37862_37919 = state_37822__$1;
(statearr_37862_37919[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (19))){
var inst_37752 = (state_37822[(7)]);
var inst_37771 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_37752);
var state_37822__$1 = state_37822;
var statearr_37863_37920 = state_37822__$1;
(statearr_37863_37920[(2)] = inst_37771);

(statearr_37863_37920[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (11))){
var inst_37752 = (state_37822[(7)]);
var inst_37756 = (inst_37752 == null);
var inst_37757 = cljs.core.not(inst_37756);
var state_37822__$1 = state_37822;
if(inst_37757){
var statearr_37864_37921 = state_37822__$1;
(statearr_37864_37921[(1)] = (13));

} else {
var statearr_37865_37922 = state_37822__$1;
(statearr_37865_37922[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (9))){
var inst_37728 = (state_37822[(8)]);
var state_37822__$1 = state_37822;
var statearr_37866_37923 = state_37822__$1;
(statearr_37866_37923[(2)] = inst_37728);

(statearr_37866_37923[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (5))){
var state_37822__$1 = state_37822;
var statearr_37867_37924 = state_37822__$1;
(statearr_37867_37924[(2)] = true);

(statearr_37867_37924[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (14))){
var state_37822__$1 = state_37822;
var statearr_37868_37925 = state_37822__$1;
(statearr_37868_37925[(2)] = false);

(statearr_37868_37925[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (26))){
var inst_37782 = (state_37822[(9)]);
var inst_37789 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_37782);
var state_37822__$1 = state_37822;
var statearr_37869_37926 = state_37822__$1;
(statearr_37869_37926[(2)] = inst_37789);

(statearr_37869_37926[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (16))){
var state_37822__$1 = state_37822;
var statearr_37870_37927 = state_37822__$1;
(statearr_37870_37927[(2)] = true);

(statearr_37870_37927[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (38))){
var inst_37812 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
var statearr_37871_37928 = state_37822__$1;
(statearr_37871_37928[(2)] = inst_37812);

(statearr_37871_37928[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (30))){
var inst_37782 = (state_37822[(9)]);
var inst_37775 = (state_37822[(11)]);
var inst_37776 = (state_37822[(13)]);
var inst_37799 = cljs.core.empty_QMARK_(inst_37775);
var inst_37800 = (inst_37776.cljs$core$IFn$_invoke$arity$1 ? inst_37776.cljs$core$IFn$_invoke$arity$1(inst_37782) : inst_37776.call(null,inst_37782));
var inst_37801 = cljs.core.not(inst_37800);
var inst_37802 = (inst_37799) && (inst_37801);
var state_37822__$1 = state_37822;
var statearr_37872_37929 = state_37822__$1;
(statearr_37872_37929[(2)] = inst_37802);

(statearr_37872_37929[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (10))){
var inst_37728 = (state_37822[(8)]);
var inst_37748 = (state_37822[(2)]);
var inst_37749 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37748,cljs.core.cst$kw$solos);
var inst_37750 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37748,cljs.core.cst$kw$mutes);
var inst_37751 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_37748,cljs.core.cst$kw$reads);
var inst_37752 = inst_37728;
var state_37822__$1 = (function (){var statearr_37873 = state_37822;
(statearr_37873[(7)] = inst_37752);

(statearr_37873[(16)] = inst_37750);

(statearr_37873[(17)] = inst_37751);

(statearr_37873[(18)] = inst_37749);

return statearr_37873;
})();
var statearr_37874_37930 = state_37822__$1;
(statearr_37874_37930[(2)] = null);

(statearr_37874_37930[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (18))){
var inst_37766 = (state_37822[(2)]);
var state_37822__$1 = state_37822;
var statearr_37875_37931 = state_37822__$1;
(statearr_37875_37931[(2)] = inst_37766);

(statearr_37875_37931[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (37))){
var state_37822__$1 = state_37822;
var statearr_37876_37932 = state_37822__$1;
(statearr_37876_37932[(2)] = null);

(statearr_37876_37932[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_37823 === (8))){
var inst_37728 = (state_37822[(8)]);
var inst_37745 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_37728);
var state_37822__$1 = state_37822;
var statearr_37877_37933 = state_37822__$1;
(statearr_37877_37933[(2)] = inst_37745);

(statearr_37877_37933[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__36040__auto__,c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__36041__auto__ = null;
var cljs$core$async$mix_$_state_machine__36041__auto____0 = (function (){
var statearr_37881 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_37881[(0)] = cljs$core$async$mix_$_state_machine__36041__auto__);

(statearr_37881[(1)] = (1));

return statearr_37881;
});
var cljs$core$async$mix_$_state_machine__36041__auto____1 = (function (state_37822){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_37822);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e37882){if((e37882 instanceof Object)){
var ex__36044__auto__ = e37882;
var statearr_37883_37934 = state_37822;
(statearr_37883_37934[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_37822);

return cljs.core.cst$kw$recur;
} else {
throw e37882;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__37935 = state_37822;
state_37822 = G__37935;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__36041__auto__ = function(state_37822){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__36041__auto____1.call(this,state_37822);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__36041__auto____0;
cljs$core$async$mix_$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__36041__auto____1;
return cljs$core$async$mix_$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__36156__auto__ = (function (){var statearr_37884 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_37884[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___37887);

return statearr_37884;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___37887,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$4 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5338__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__5338__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$4 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__5338__auto____$1.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5338__auto__.call(null,p,v,ch));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__5338__auto____$1.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args37936 = [];
var len__5740__auto___37939 = arguments.length;
var i__5741__auto___37940 = (0);
while(true){
if((i__5741__auto___37940 < len__5740__auto___37939)){
args37936.push((arguments[i__5741__auto___37940]));

var G__37941 = (i__5741__auto___37940 + (1));
i__5741__auto___37940 = G__37941;
continue;
} else {
}
break;
}

var G__37938 = args37936.length;
switch (G__37938) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37936.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__5338__auto__.call(null,p));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$1(p) : m__5338__auto____$1.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__5337__auto__ = (((p == null))?null:p);
var m__5338__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5337__auto__)]);
if(!((m__5338__auto__ == null))){
return (m__5338__auto__.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__5338__auto__.call(null,p,v));
} else {
var m__5338__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5338__auto____$1 == null))){
return (m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__5338__auto____$1.cljs$core$IFn$_invoke$arity$2(p,v) : m__5338__auto____$1.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args37944 = [];
var len__5740__auto___38072 = arguments.length;
var i__5741__auto___38073 = (0);
while(true){
if((i__5741__auto___38073 < len__5740__auto___38072)){
args37944.push((arguments[i__5741__auto___38073]));

var G__38074 = (i__5741__auto___38073 + (1));
i__5741__auto___38073 = G__38074;
continue;
} else {
}
break;
}

var G__37946 = args37944.length;
switch (G__37946) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args37944.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = (function (){var G__37947 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__37947) : cljs.core.atom.call(null,G__37947));
})();
var ensure_mult = ((function (mults){
return (function (topic){
var or__4682__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults)),topic);
if(cljs.core.truth_(or__4682__auto__)){
return or__4682__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__4682__auto__,mults){
return (function (p1__37943_SHARP_){
if(cljs.core.truth_((p1__37943_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__37943_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__37943_SHARP_.call(null,topic)))){
return p1__37943_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__37943_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
});})(or__4682__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async37948 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async37948 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta37949){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta37949 = meta37949;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_37950,meta37949__$1){
var self__ = this;
var _37950__$1 = this;
return (new cljs.core.async.t_cljs$core$async37948(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta37949__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_37950){
var self__ = this;
var _37950__$1 = this;
return self__.meta37949;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4653__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.mults) : cljs.core.deref.call(null,self__.mults)),topic);
if(cljs.core.truth_(temp__4653__auto__)){
var m = temp__4653__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__37951 = self__.mults;
var G__37952 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__37951,G__37952) : cljs.core.reset_BANG_.call(null,G__37951,G__37952));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$topic_DASH_fn,cljs.core.cst$sym$buf_DASH_fn,cljs.core.cst$sym$mults,cljs.core.cst$sym$ensure_DASH_mult,cljs.core.cst$sym$meta37949], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async37948.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async37948.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async37948";

cljs.core.async.t_cljs$core$async37948.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async37948");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async37948 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async37948(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta37949){
return (new cljs.core.async.t_cljs$core$async37948(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta37949));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async37948(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__36154__auto___38076 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38076,mults,ensure_mult,p){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38076,mults,ensure_mult,p){
return (function (state_38024){
var state_val_38025 = (state_38024[(1)]);
if((state_val_38025 === (7))){
var inst_38020 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38026_38077 = state_38024__$1;
(statearr_38026_38077[(2)] = inst_38020);

(statearr_38026_38077[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (20))){
var state_38024__$1 = state_38024;
var statearr_38027_38078 = state_38024__$1;
(statearr_38027_38078[(2)] = null);

(statearr_38027_38078[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (1))){
var state_38024__$1 = state_38024;
var statearr_38028_38079 = state_38024__$1;
(statearr_38028_38079[(2)] = null);

(statearr_38028_38079[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (24))){
var inst_38003 = (state_38024[(7)]);
var inst_38012 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_38003);
var state_38024__$1 = state_38024;
var statearr_38029_38080 = state_38024__$1;
(statearr_38029_38080[(2)] = inst_38012);

(statearr_38029_38080[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (4))){
var inst_37955 = (state_38024[(8)]);
var inst_37955__$1 = (state_38024[(2)]);
var inst_37956 = (inst_37955__$1 == null);
var state_38024__$1 = (function (){var statearr_38030 = state_38024;
(statearr_38030[(8)] = inst_37955__$1);

return statearr_38030;
})();
if(cljs.core.truth_(inst_37956)){
var statearr_38031_38081 = state_38024__$1;
(statearr_38031_38081[(1)] = (5));

} else {
var statearr_38032_38082 = state_38024__$1;
(statearr_38032_38082[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (15))){
var inst_37997 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38033_38083 = state_38024__$1;
(statearr_38033_38083[(2)] = inst_37997);

(statearr_38033_38083[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (21))){
var inst_38017 = (state_38024[(2)]);
var state_38024__$1 = (function (){var statearr_38034 = state_38024;
(statearr_38034[(9)] = inst_38017);

return statearr_38034;
})();
var statearr_38035_38084 = state_38024__$1;
(statearr_38035_38084[(2)] = null);

(statearr_38035_38084[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (13))){
var inst_37979 = (state_38024[(10)]);
var inst_37981 = cljs.core.chunked_seq_QMARK_(inst_37979);
var state_38024__$1 = state_38024;
if(inst_37981){
var statearr_38036_38085 = state_38024__$1;
(statearr_38036_38085[(1)] = (16));

} else {
var statearr_38037_38086 = state_38024__$1;
(statearr_38037_38086[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (22))){
var inst_38009 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
if(cljs.core.truth_(inst_38009)){
var statearr_38038_38087 = state_38024__$1;
(statearr_38038_38087[(1)] = (23));

} else {
var statearr_38039_38088 = state_38024__$1;
(statearr_38039_38088[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (6))){
var inst_38003 = (state_38024[(7)]);
var inst_38005 = (state_38024[(11)]);
var inst_37955 = (state_38024[(8)]);
var inst_38003__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_37955) : topic_fn.call(null,inst_37955));
var inst_38004 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_38005__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_38004,inst_38003__$1);
var state_38024__$1 = (function (){var statearr_38040 = state_38024;
(statearr_38040[(7)] = inst_38003__$1);

(statearr_38040[(11)] = inst_38005__$1);

return statearr_38040;
})();
if(cljs.core.truth_(inst_38005__$1)){
var statearr_38041_38089 = state_38024__$1;
(statearr_38041_38089[(1)] = (19));

} else {
var statearr_38042_38090 = state_38024__$1;
(statearr_38042_38090[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (25))){
var inst_38014 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38043_38091 = state_38024__$1;
(statearr_38043_38091[(2)] = inst_38014);

(statearr_38043_38091[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (17))){
var inst_37979 = (state_38024[(10)]);
var inst_37988 = cljs.core.first(inst_37979);
var inst_37989 = cljs.core.async.muxch_STAR_(inst_37988);
var inst_37990 = cljs.core.async.close_BANG_(inst_37989);
var inst_37991 = cljs.core.next(inst_37979);
var inst_37965 = inst_37991;
var inst_37966 = null;
var inst_37967 = (0);
var inst_37968 = (0);
var state_38024__$1 = (function (){var statearr_38044 = state_38024;
(statearr_38044[(12)] = inst_37965);

(statearr_38044[(13)] = inst_37968);

(statearr_38044[(14)] = inst_37967);

(statearr_38044[(15)] = inst_37966);

(statearr_38044[(16)] = inst_37990);

return statearr_38044;
})();
var statearr_38045_38092 = state_38024__$1;
(statearr_38045_38092[(2)] = null);

(statearr_38045_38092[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (3))){
var inst_38022 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38024__$1,inst_38022);
} else {
if((state_val_38025 === (12))){
var inst_37999 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38046_38093 = state_38024__$1;
(statearr_38046_38093[(2)] = inst_37999);

(statearr_38046_38093[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (2))){
var state_38024__$1 = state_38024;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38024__$1,(4),ch);
} else {
if((state_val_38025 === (23))){
var state_38024__$1 = state_38024;
var statearr_38047_38094 = state_38024__$1;
(statearr_38047_38094[(2)] = null);

(statearr_38047_38094[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (19))){
var inst_38005 = (state_38024[(11)]);
var inst_37955 = (state_38024[(8)]);
var inst_38007 = cljs.core.async.muxch_STAR_(inst_38005);
var state_38024__$1 = state_38024;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38024__$1,(22),inst_38007,inst_37955);
} else {
if((state_val_38025 === (11))){
var inst_37965 = (state_38024[(12)]);
var inst_37979 = (state_38024[(10)]);
var inst_37979__$1 = cljs.core.seq(inst_37965);
var state_38024__$1 = (function (){var statearr_38048 = state_38024;
(statearr_38048[(10)] = inst_37979__$1);

return statearr_38048;
})();
if(inst_37979__$1){
var statearr_38049_38095 = state_38024__$1;
(statearr_38049_38095[(1)] = (13));

} else {
var statearr_38050_38096 = state_38024__$1;
(statearr_38050_38096[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (9))){
var inst_38001 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38051_38097 = state_38024__$1;
(statearr_38051_38097[(2)] = inst_38001);

(statearr_38051_38097[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (5))){
var inst_37962 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_37963 = cljs.core.vals(inst_37962);
var inst_37964 = cljs.core.seq(inst_37963);
var inst_37965 = inst_37964;
var inst_37966 = null;
var inst_37967 = (0);
var inst_37968 = (0);
var state_38024__$1 = (function (){var statearr_38052 = state_38024;
(statearr_38052[(12)] = inst_37965);

(statearr_38052[(13)] = inst_37968);

(statearr_38052[(14)] = inst_37967);

(statearr_38052[(15)] = inst_37966);

return statearr_38052;
})();
var statearr_38053_38098 = state_38024__$1;
(statearr_38053_38098[(2)] = null);

(statearr_38053_38098[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (14))){
var state_38024__$1 = state_38024;
var statearr_38057_38099 = state_38024__$1;
(statearr_38057_38099[(2)] = null);

(statearr_38057_38099[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (16))){
var inst_37979 = (state_38024[(10)]);
var inst_37983 = cljs.core.chunk_first(inst_37979);
var inst_37984 = cljs.core.chunk_rest(inst_37979);
var inst_37985 = cljs.core.count(inst_37983);
var inst_37965 = inst_37984;
var inst_37966 = inst_37983;
var inst_37967 = inst_37985;
var inst_37968 = (0);
var state_38024__$1 = (function (){var statearr_38058 = state_38024;
(statearr_38058[(12)] = inst_37965);

(statearr_38058[(13)] = inst_37968);

(statearr_38058[(14)] = inst_37967);

(statearr_38058[(15)] = inst_37966);

return statearr_38058;
})();
var statearr_38059_38100 = state_38024__$1;
(statearr_38059_38100[(2)] = null);

(statearr_38059_38100[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (10))){
var inst_37965 = (state_38024[(12)]);
var inst_37968 = (state_38024[(13)]);
var inst_37967 = (state_38024[(14)]);
var inst_37966 = (state_38024[(15)]);
var inst_37973 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_37966,inst_37968);
var inst_37974 = cljs.core.async.muxch_STAR_(inst_37973);
var inst_37975 = cljs.core.async.close_BANG_(inst_37974);
var inst_37976 = (inst_37968 + (1));
var tmp38054 = inst_37965;
var tmp38055 = inst_37967;
var tmp38056 = inst_37966;
var inst_37965__$1 = tmp38054;
var inst_37966__$1 = tmp38056;
var inst_37967__$1 = tmp38055;
var inst_37968__$1 = inst_37976;
var state_38024__$1 = (function (){var statearr_38060 = state_38024;
(statearr_38060[(12)] = inst_37965__$1);

(statearr_38060[(17)] = inst_37975);

(statearr_38060[(13)] = inst_37968__$1);

(statearr_38060[(14)] = inst_37967__$1);

(statearr_38060[(15)] = inst_37966__$1);

return statearr_38060;
})();
var statearr_38061_38101 = state_38024__$1;
(statearr_38061_38101[(2)] = null);

(statearr_38061_38101[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (18))){
var inst_37994 = (state_38024[(2)]);
var state_38024__$1 = state_38024;
var statearr_38062_38102 = state_38024__$1;
(statearr_38062_38102[(2)] = inst_37994);

(statearr_38062_38102[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38025 === (8))){
var inst_37968 = (state_38024[(13)]);
var inst_37967 = (state_38024[(14)]);
var inst_37970 = (inst_37968 < inst_37967);
var inst_37971 = inst_37970;
var state_38024__$1 = state_38024;
if(cljs.core.truth_(inst_37971)){
var statearr_38063_38103 = state_38024__$1;
(statearr_38063_38103[(1)] = (10));

} else {
var statearr_38064_38104 = state_38024__$1;
(statearr_38064_38104[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38076,mults,ensure_mult,p))
;
return ((function (switch__36040__auto__,c__36154__auto___38076,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38068 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38068[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38068[(1)] = (1));

return statearr_38068;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38024){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38024);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38069){if((e38069 instanceof Object)){
var ex__36044__auto__ = e38069;
var statearr_38070_38105 = state_38024;
(statearr_38070_38105[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38024);

return cljs.core.cst$kw$recur;
} else {
throw e38069;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38106 = state_38024;
state_38024 = G__38106;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38024){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38024);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38076,mults,ensure_mult,p))
})();
var state__36156__auto__ = (function (){var statearr_38071 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38071[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38076);

return statearr_38071;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38076,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args38107 = [];
var len__5740__auto___38110 = arguments.length;
var i__5741__auto___38111 = (0);
while(true){
if((i__5741__auto___38111 < len__5740__auto___38110)){
args38107.push((arguments[i__5741__auto___38111]));

var G__38112 = (i__5741__auto___38111 + (1));
i__5741__auto___38111 = G__38112;
continue;
} else {
}
break;
}

var G__38109 = args38107.length;
switch (G__38109) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38107.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args38114 = [];
var len__5740__auto___38117 = arguments.length;
var i__5741__auto___38118 = (0);
while(true){
if((i__5741__auto___38118 < len__5740__auto___38117)){
args38114.push((arguments[i__5741__auto___38118]));

var G__38119 = (i__5741__auto___38118 + (1));
i__5741__auto___38118 = G__38119;
continue;
} else {
}
break;
}

var G__38116 = args38114.length;
switch (G__38116) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38114.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args38121 = [];
var len__5740__auto___38192 = arguments.length;
var i__5741__auto___38193 = (0);
while(true){
if((i__5741__auto___38193 < len__5740__auto___38192)){
args38121.push((arguments[i__5741__auto___38193]));

var G__38194 = (i__5741__auto___38193 + (1));
i__5741__auto___38193 = G__38194;
continue;
} else {
}
break;
}

var G__38123 = args38121.length;
switch (G__38123) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38121.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__36154__auto___38196 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_38162){
var state_val_38163 = (state_38162[(1)]);
if((state_val_38163 === (7))){
var state_38162__$1 = state_38162;
var statearr_38164_38197 = state_38162__$1;
(statearr_38164_38197[(2)] = null);

(statearr_38164_38197[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (1))){
var state_38162__$1 = state_38162;
var statearr_38165_38198 = state_38162__$1;
(statearr_38165_38198[(2)] = null);

(statearr_38165_38198[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (4))){
var inst_38126 = (state_38162[(7)]);
var inst_38128 = (inst_38126 < cnt);
var state_38162__$1 = state_38162;
if(cljs.core.truth_(inst_38128)){
var statearr_38166_38199 = state_38162__$1;
(statearr_38166_38199[(1)] = (6));

} else {
var statearr_38167_38200 = state_38162__$1;
(statearr_38167_38200[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (15))){
var inst_38158 = (state_38162[(2)]);
var state_38162__$1 = state_38162;
var statearr_38168_38201 = state_38162__$1;
(statearr_38168_38201[(2)] = inst_38158);

(statearr_38168_38201[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (13))){
var inst_38151 = cljs.core.async.close_BANG_(out);
var state_38162__$1 = state_38162;
var statearr_38169_38202 = state_38162__$1;
(statearr_38169_38202[(2)] = inst_38151);

(statearr_38169_38202[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (6))){
var state_38162__$1 = state_38162;
var statearr_38170_38203 = state_38162__$1;
(statearr_38170_38203[(2)] = null);

(statearr_38170_38203[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (3))){
var inst_38160 = (state_38162[(2)]);
var state_38162__$1 = state_38162;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38162__$1,inst_38160);
} else {
if((state_val_38163 === (12))){
var inst_38148 = (state_38162[(8)]);
var inst_38148__$1 = (state_38162[(2)]);
var inst_38149 = cljs.core.some(cljs.core.nil_QMARK_,inst_38148__$1);
var state_38162__$1 = (function (){var statearr_38171 = state_38162;
(statearr_38171[(8)] = inst_38148__$1);

return statearr_38171;
})();
if(cljs.core.truth_(inst_38149)){
var statearr_38172_38204 = state_38162__$1;
(statearr_38172_38204[(1)] = (13));

} else {
var statearr_38173_38205 = state_38162__$1;
(statearr_38173_38205[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (2))){
var inst_38125 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cnt) : cljs.core.reset_BANG_.call(null,dctr,cnt));
var inst_38126 = (0);
var state_38162__$1 = (function (){var statearr_38174 = state_38162;
(statearr_38174[(9)] = inst_38125);

(statearr_38174[(7)] = inst_38126);

return statearr_38174;
})();
var statearr_38175_38206 = state_38162__$1;
(statearr_38175_38206[(2)] = null);

(statearr_38175_38206[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (11))){
var inst_38126 = (state_38162[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_38162,(10),Object,null,(9));
var inst_38135 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_38126) : chs__$1.call(null,inst_38126));
var inst_38136 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_38126) : done.call(null,inst_38126));
var inst_38137 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_38135,inst_38136);
var state_38162__$1 = state_38162;
var statearr_38176_38207 = state_38162__$1;
(statearr_38176_38207[(2)] = inst_38137);


cljs.core.async.impl.ioc_helpers.process_exception(state_38162__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (9))){
var inst_38126 = (state_38162[(7)]);
var inst_38139 = (state_38162[(2)]);
var inst_38140 = (inst_38126 + (1));
var inst_38126__$1 = inst_38140;
var state_38162__$1 = (function (){var statearr_38177 = state_38162;
(statearr_38177[(7)] = inst_38126__$1);

(statearr_38177[(10)] = inst_38139);

return statearr_38177;
})();
var statearr_38178_38208 = state_38162__$1;
(statearr_38178_38208[(2)] = null);

(statearr_38178_38208[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (5))){
var inst_38146 = (state_38162[(2)]);
var state_38162__$1 = (function (){var statearr_38179 = state_38162;
(statearr_38179[(11)] = inst_38146);

return statearr_38179;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38162__$1,(12),dchan);
} else {
if((state_val_38163 === (14))){
var inst_38148 = (state_38162[(8)]);
var inst_38153 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_38148);
var state_38162__$1 = state_38162;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38162__$1,(16),out,inst_38153);
} else {
if((state_val_38163 === (16))){
var inst_38155 = (state_38162[(2)]);
var state_38162__$1 = (function (){var statearr_38180 = state_38162;
(statearr_38180[(12)] = inst_38155);

return statearr_38180;
})();
var statearr_38181_38209 = state_38162__$1;
(statearr_38181_38209[(2)] = null);

(statearr_38181_38209[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (10))){
var inst_38130 = (state_38162[(2)]);
var inst_38131 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_38162__$1 = (function (){var statearr_38182 = state_38162;
(statearr_38182[(13)] = inst_38130);

return statearr_38182;
})();
var statearr_38183_38210 = state_38162__$1;
(statearr_38183_38210[(2)] = inst_38131);


cljs.core.async.impl.ioc_helpers.process_exception(state_38162__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_38163 === (8))){
var inst_38144 = (state_38162[(2)]);
var state_38162__$1 = state_38162;
var statearr_38184_38211 = state_38162__$1;
(statearr_38184_38211[(2)] = inst_38144);

(statearr_38184_38211[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__36040__auto__,c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38188 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38188[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38188[(1)] = (1));

return statearr_38188;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38162){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38162);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38189){if((e38189 instanceof Object)){
var ex__36044__auto__ = e38189;
var statearr_38190_38212 = state_38162;
(statearr_38190_38212[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38162);

return cljs.core.cst$kw$recur;
} else {
throw e38189;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38213 = state_38162;
state_38162 = G__38213;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38162){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38162);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__36156__auto__ = (function (){var statearr_38191 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38191[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38196);

return statearr_38191;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38196,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args38215 = [];
var len__5740__auto___38271 = arguments.length;
var i__5741__auto___38272 = (0);
while(true){
if((i__5741__auto___38272 < len__5740__auto___38271)){
args38215.push((arguments[i__5741__auto___38272]));

var G__38273 = (i__5741__auto___38272 + (1));
i__5741__auto___38272 = G__38273;
continue;
} else {
}
break;
}

var G__38217 = args38215.length;
switch (G__38217) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38215.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38275 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38275,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38275,out){
return (function (state_38247){
var state_val_38248 = (state_38247[(1)]);
if((state_val_38248 === (7))){
var inst_38227 = (state_38247[(7)]);
var inst_38226 = (state_38247[(8)]);
var inst_38226__$1 = (state_38247[(2)]);
var inst_38227__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_38226__$1,(0),null);
var inst_38228 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_38226__$1,(1),null);
var inst_38229 = (inst_38227__$1 == null);
var state_38247__$1 = (function (){var statearr_38249 = state_38247;
(statearr_38249[(9)] = inst_38228);

(statearr_38249[(7)] = inst_38227__$1);

(statearr_38249[(8)] = inst_38226__$1);

return statearr_38249;
})();
if(cljs.core.truth_(inst_38229)){
var statearr_38250_38276 = state_38247__$1;
(statearr_38250_38276[(1)] = (8));

} else {
var statearr_38251_38277 = state_38247__$1;
(statearr_38251_38277[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (1))){
var inst_38218 = cljs.core.vec(chs);
var inst_38219 = inst_38218;
var state_38247__$1 = (function (){var statearr_38252 = state_38247;
(statearr_38252[(10)] = inst_38219);

return statearr_38252;
})();
var statearr_38253_38278 = state_38247__$1;
(statearr_38253_38278[(2)] = null);

(statearr_38253_38278[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (4))){
var inst_38219 = (state_38247[(10)]);
var state_38247__$1 = state_38247;
return cljs.core.async.ioc_alts_BANG_(state_38247__$1,(7),inst_38219);
} else {
if((state_val_38248 === (6))){
var inst_38243 = (state_38247[(2)]);
var state_38247__$1 = state_38247;
var statearr_38254_38279 = state_38247__$1;
(statearr_38254_38279[(2)] = inst_38243);

(statearr_38254_38279[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (3))){
var inst_38245 = (state_38247[(2)]);
var state_38247__$1 = state_38247;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38247__$1,inst_38245);
} else {
if((state_val_38248 === (2))){
var inst_38219 = (state_38247[(10)]);
var inst_38221 = cljs.core.count(inst_38219);
var inst_38222 = (inst_38221 > (0));
var state_38247__$1 = state_38247;
if(cljs.core.truth_(inst_38222)){
var statearr_38256_38280 = state_38247__$1;
(statearr_38256_38280[(1)] = (4));

} else {
var statearr_38257_38281 = state_38247__$1;
(statearr_38257_38281[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (11))){
var inst_38219 = (state_38247[(10)]);
var inst_38236 = (state_38247[(2)]);
var tmp38255 = inst_38219;
var inst_38219__$1 = tmp38255;
var state_38247__$1 = (function (){var statearr_38258 = state_38247;
(statearr_38258[(11)] = inst_38236);

(statearr_38258[(10)] = inst_38219__$1);

return statearr_38258;
})();
var statearr_38259_38282 = state_38247__$1;
(statearr_38259_38282[(2)] = null);

(statearr_38259_38282[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (9))){
var inst_38227 = (state_38247[(7)]);
var state_38247__$1 = state_38247;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38247__$1,(11),out,inst_38227);
} else {
if((state_val_38248 === (5))){
var inst_38241 = cljs.core.async.close_BANG_(out);
var state_38247__$1 = state_38247;
var statearr_38260_38283 = state_38247__$1;
(statearr_38260_38283[(2)] = inst_38241);

(statearr_38260_38283[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (10))){
var inst_38239 = (state_38247[(2)]);
var state_38247__$1 = state_38247;
var statearr_38261_38284 = state_38247__$1;
(statearr_38261_38284[(2)] = inst_38239);

(statearr_38261_38284[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38248 === (8))){
var inst_38228 = (state_38247[(9)]);
var inst_38227 = (state_38247[(7)]);
var inst_38226 = (state_38247[(8)]);
var inst_38219 = (state_38247[(10)]);
var inst_38231 = (function (){var cs = inst_38219;
var vec__38224 = inst_38226;
var v = inst_38227;
var c = inst_38228;
return ((function (cs,vec__38224,v,c,inst_38228,inst_38227,inst_38226,inst_38219,state_val_38248,c__36154__auto___38275,out){
return (function (p1__38214_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__38214_SHARP_);
});
;})(cs,vec__38224,v,c,inst_38228,inst_38227,inst_38226,inst_38219,state_val_38248,c__36154__auto___38275,out))
})();
var inst_38232 = cljs.core.filterv(inst_38231,inst_38219);
var inst_38219__$1 = inst_38232;
var state_38247__$1 = (function (){var statearr_38262 = state_38247;
(statearr_38262[(10)] = inst_38219__$1);

return statearr_38262;
})();
var statearr_38263_38285 = state_38247__$1;
(statearr_38263_38285[(2)] = null);

(statearr_38263_38285[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38275,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38275,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38267 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38267[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38267[(1)] = (1));

return statearr_38267;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38247){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38247);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38268){if((e38268 instanceof Object)){
var ex__36044__auto__ = e38268;
var statearr_38269_38286 = state_38247;
(statearr_38269_38286[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38247);

return cljs.core.cst$kw$recur;
} else {
throw e38268;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38287 = state_38247;
state_38247 = G__38287;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38247){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38247);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38275,out))
})();
var state__36156__auto__ = (function (){var statearr_38270 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38270[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38275);

return statearr_38270;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38275,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args38288 = [];
var len__5740__auto___38337 = arguments.length;
var i__5741__auto___38338 = (0);
while(true){
if((i__5741__auto___38338 < len__5740__auto___38337)){
args38288.push((arguments[i__5741__auto___38338]));

var G__38339 = (i__5741__auto___38338 + (1));
i__5741__auto___38338 = G__38339;
continue;
} else {
}
break;
}

var G__38290 = args38288.length;
switch (G__38290) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38288.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38341 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38341,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38341,out){
return (function (state_38314){
var state_val_38315 = (state_38314[(1)]);
if((state_val_38315 === (7))){
var inst_38296 = (state_38314[(7)]);
var inst_38296__$1 = (state_38314[(2)]);
var inst_38297 = (inst_38296__$1 == null);
var inst_38298 = cljs.core.not(inst_38297);
var state_38314__$1 = (function (){var statearr_38316 = state_38314;
(statearr_38316[(7)] = inst_38296__$1);

return statearr_38316;
})();
if(inst_38298){
var statearr_38317_38342 = state_38314__$1;
(statearr_38317_38342[(1)] = (8));

} else {
var statearr_38318_38343 = state_38314__$1;
(statearr_38318_38343[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (1))){
var inst_38291 = (0);
var state_38314__$1 = (function (){var statearr_38319 = state_38314;
(statearr_38319[(8)] = inst_38291);

return statearr_38319;
})();
var statearr_38320_38344 = state_38314__$1;
(statearr_38320_38344[(2)] = null);

(statearr_38320_38344[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (4))){
var state_38314__$1 = state_38314;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38314__$1,(7),ch);
} else {
if((state_val_38315 === (6))){
var inst_38309 = (state_38314[(2)]);
var state_38314__$1 = state_38314;
var statearr_38321_38345 = state_38314__$1;
(statearr_38321_38345[(2)] = inst_38309);

(statearr_38321_38345[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (3))){
var inst_38311 = (state_38314[(2)]);
var inst_38312 = cljs.core.async.close_BANG_(out);
var state_38314__$1 = (function (){var statearr_38322 = state_38314;
(statearr_38322[(9)] = inst_38311);

return statearr_38322;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_38314__$1,inst_38312);
} else {
if((state_val_38315 === (2))){
var inst_38291 = (state_38314[(8)]);
var inst_38293 = (inst_38291 < n);
var state_38314__$1 = state_38314;
if(cljs.core.truth_(inst_38293)){
var statearr_38323_38346 = state_38314__$1;
(statearr_38323_38346[(1)] = (4));

} else {
var statearr_38324_38347 = state_38314__$1;
(statearr_38324_38347[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (11))){
var inst_38291 = (state_38314[(8)]);
var inst_38301 = (state_38314[(2)]);
var inst_38302 = (inst_38291 + (1));
var inst_38291__$1 = inst_38302;
var state_38314__$1 = (function (){var statearr_38325 = state_38314;
(statearr_38325[(8)] = inst_38291__$1);

(statearr_38325[(10)] = inst_38301);

return statearr_38325;
})();
var statearr_38326_38348 = state_38314__$1;
(statearr_38326_38348[(2)] = null);

(statearr_38326_38348[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (9))){
var state_38314__$1 = state_38314;
var statearr_38327_38349 = state_38314__$1;
(statearr_38327_38349[(2)] = null);

(statearr_38327_38349[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (5))){
var state_38314__$1 = state_38314;
var statearr_38328_38350 = state_38314__$1;
(statearr_38328_38350[(2)] = null);

(statearr_38328_38350[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (10))){
var inst_38306 = (state_38314[(2)]);
var state_38314__$1 = state_38314;
var statearr_38329_38351 = state_38314__$1;
(statearr_38329_38351[(2)] = inst_38306);

(statearr_38329_38351[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38315 === (8))){
var inst_38296 = (state_38314[(7)]);
var state_38314__$1 = state_38314;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38314__$1,(11),out,inst_38296);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38341,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38341,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38333 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_38333[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38333[(1)] = (1));

return statearr_38333;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38314){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38314);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38334){if((e38334 instanceof Object)){
var ex__36044__auto__ = e38334;
var statearr_38335_38352 = state_38314;
(statearr_38335_38352[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38314);

return cljs.core.cst$kw$recur;
} else {
throw e38334;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38353 = state_38314;
state_38314 = G__38353;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38314){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38314);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38341,out))
})();
var state__36156__auto__ = (function (){var statearr_38336 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38336[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38341);

return statearr_38336;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38341,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async38363 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38363 = (function (map_LT_,f,ch,meta38364){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta38364 = meta38364;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38365,meta38364__$1){
var self__ = this;
var _38365__$1 = this;
return (new cljs.core.async.t_cljs$core$async38363(self__.map_LT_,self__.f,self__.ch,meta38364__$1));
});

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38365){
var self__ = this;
var _38365__$1 = this;
return self__.meta38364;
});

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async38366 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38366 = (function (map_LT_,f,ch,meta38364,_,fn1,meta38367){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta38364 = meta38364;
this._ = _;
this.fn1 = fn1;
this.meta38367 = meta38367;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_38368,meta38367__$1){
var self__ = this;
var _38368__$1 = this;
return (new cljs.core.async.t_cljs$core$async38366(self__.map_LT_,self__.f,self__.ch,self__.meta38364,self__._,self__.fn1,meta38367__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_38368){
var self__ = this;
var _38368__$1 = this;
return self__.meta38367;
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__38354_SHARP_){
var G__38369 = (((p1__38354_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__38354_SHARP_) : self__.f.call(null,p1__38354_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__38369) : f1.call(null,G__38369));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38364,cljs.core.with_meta(cljs.core.cst$sym$_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$tag,cljs.core.cst$sym$cljs$core$async_SLASH_t_cljs$core$async38363], null)),cljs.core.cst$sym$fn1,cljs.core.cst$sym$meta38367], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async38366.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38366.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38366";

cljs.core.async.t_cljs$core$async38366.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38366");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async38366 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async38366(map_LT___$1,f__$1,ch__$1,meta38364__$1,___$2,fn1__$1,meta38367){
return (new cljs.core.async.t_cljs$core$async38366(map_LT___$1,f__$1,ch__$1,meta38364__$1,___$2,fn1__$1,meta38367));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async38366(self__.map_LT_,self__.f,self__.ch,self__.meta38364,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4670__auto__ = ret;
if(cljs.core.truth_(and__4670__auto__)){
return !(((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret)) == null));
} else {
return and__4670__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__38370 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__38370) : self__.f.call(null,G__38370));
})());
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38363.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async38363.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38364], null);
});

cljs.core.async.t_cljs$core$async38363.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38363.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38363";

cljs.core.async.t_cljs$core$async38363.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38363");
});

cljs.core.async.__GT_t_cljs$core$async38363 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async38363(map_LT___$1,f__$1,ch__$1,meta38364){
return (new cljs.core.async.t_cljs$core$async38363(map_LT___$1,f__$1,ch__$1,meta38364));
});

}

return (new cljs.core.async.t_cljs$core$async38363(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async38374 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38374 = (function (map_GT_,f,ch,meta38375){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta38375 = meta38375;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38376,meta38375__$1){
var self__ = this;
var _38376__$1 = this;
return (new cljs.core.async.t_cljs$core$async38374(self__.map_GT_,self__.f,self__.ch,meta38375__$1));
});

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38376){
var self__ = this;
var _38376__$1 = this;
return self__.meta38375;
});

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38374.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
});

cljs.core.async.t_cljs$core$async38374.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38375], null);
});

cljs.core.async.t_cljs$core$async38374.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38374.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38374";

cljs.core.async.t_cljs$core$async38374.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38374");
});

cljs.core.async.__GT_t_cljs$core$async38374 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async38374(map_GT___$1,f__$1,ch__$1,meta38375){
return (new cljs.core.async.t_cljs$core$async38374(map_GT___$1,f__$1,ch__$1,meta38375));
});

}

return (new cljs.core.async.t_cljs$core$async38374(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async38380 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async38380 = (function (filter_GT_,p,ch,meta38381){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta38381 = meta38381;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38382,meta38381__$1){
var self__ = this;
var _38382__$1 = this;
return (new cljs.core.async.t_cljs$core$async38380(self__.filter_GT_,self__.p,self__.ch,meta38381__$1));
});

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38382){
var self__ = this;
var _38382__$1 = this;
return self__.meta38381;
});

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async38380.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t_cljs$core$async38380.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$filter_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$p,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$p,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta38381], null);
});

cljs.core.async.t_cljs$core$async38380.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async38380.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async38380";

cljs.core.async.t_cljs$core$async38380.cljs$lang$ctorPrWriter = (function (this__5280__auto__,writer__5281__auto__,opt__5282__auto__){
return cljs.core._write(writer__5281__auto__,"cljs.core.async/t_cljs$core$async38380");
});

cljs.core.async.__GT_t_cljs$core$async38380 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async38380(filter_GT___$1,p__$1,ch__$1,meta38381){
return (new cljs.core.async.t_cljs$core$async38380(filter_GT___$1,p__$1,ch__$1,meta38381));
});

}

return (new cljs.core.async.t_cljs$core$async38380(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args38383 = [];
var len__5740__auto___38427 = arguments.length;
var i__5741__auto___38428 = (0);
while(true){
if((i__5741__auto___38428 < len__5740__auto___38427)){
args38383.push((arguments[i__5741__auto___38428]));

var G__38429 = (i__5741__auto___38428 + (1));
i__5741__auto___38428 = G__38429;
continue;
} else {
}
break;
}

var G__38385 = args38383.length;
switch (G__38385) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38383.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38431 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38431,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38431,out){
return (function (state_38406){
var state_val_38407 = (state_38406[(1)]);
if((state_val_38407 === (7))){
var inst_38402 = (state_38406[(2)]);
var state_38406__$1 = state_38406;
var statearr_38408_38432 = state_38406__$1;
(statearr_38408_38432[(2)] = inst_38402);

(statearr_38408_38432[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (1))){
var state_38406__$1 = state_38406;
var statearr_38409_38433 = state_38406__$1;
(statearr_38409_38433[(2)] = null);

(statearr_38409_38433[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (4))){
var inst_38388 = (state_38406[(7)]);
var inst_38388__$1 = (state_38406[(2)]);
var inst_38389 = (inst_38388__$1 == null);
var state_38406__$1 = (function (){var statearr_38410 = state_38406;
(statearr_38410[(7)] = inst_38388__$1);

return statearr_38410;
})();
if(cljs.core.truth_(inst_38389)){
var statearr_38411_38434 = state_38406__$1;
(statearr_38411_38434[(1)] = (5));

} else {
var statearr_38412_38435 = state_38406__$1;
(statearr_38412_38435[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (6))){
var inst_38388 = (state_38406[(7)]);
var inst_38393 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_38388) : p.call(null,inst_38388));
var state_38406__$1 = state_38406;
if(cljs.core.truth_(inst_38393)){
var statearr_38413_38436 = state_38406__$1;
(statearr_38413_38436[(1)] = (8));

} else {
var statearr_38414_38437 = state_38406__$1;
(statearr_38414_38437[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (3))){
var inst_38404 = (state_38406[(2)]);
var state_38406__$1 = state_38406;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38406__$1,inst_38404);
} else {
if((state_val_38407 === (2))){
var state_38406__$1 = state_38406;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38406__$1,(4),ch);
} else {
if((state_val_38407 === (11))){
var inst_38396 = (state_38406[(2)]);
var state_38406__$1 = state_38406;
var statearr_38415_38438 = state_38406__$1;
(statearr_38415_38438[(2)] = inst_38396);

(statearr_38415_38438[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (9))){
var state_38406__$1 = state_38406;
var statearr_38416_38439 = state_38406__$1;
(statearr_38416_38439[(2)] = null);

(statearr_38416_38439[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (5))){
var inst_38391 = cljs.core.async.close_BANG_(out);
var state_38406__$1 = state_38406;
var statearr_38417_38440 = state_38406__$1;
(statearr_38417_38440[(2)] = inst_38391);

(statearr_38417_38440[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (10))){
var inst_38399 = (state_38406[(2)]);
var state_38406__$1 = (function (){var statearr_38418 = state_38406;
(statearr_38418[(8)] = inst_38399);

return statearr_38418;
})();
var statearr_38419_38441 = state_38406__$1;
(statearr_38419_38441[(2)] = null);

(statearr_38419_38441[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38407 === (8))){
var inst_38388 = (state_38406[(7)]);
var state_38406__$1 = state_38406;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38406__$1,(11),out,inst_38388);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38431,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38431,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38423 = [null,null,null,null,null,null,null,null,null];
(statearr_38423[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38423[(1)] = (1));

return statearr_38423;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38406){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38406);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38424){if((e38424 instanceof Object)){
var ex__36044__auto__ = e38424;
var statearr_38425_38442 = state_38406;
(statearr_38425_38442[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38406);

return cljs.core.cst$kw$recur;
} else {
throw e38424;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38443 = state_38406;
state_38406 = G__38443;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38406){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38406);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38431,out))
})();
var state__36156__auto__ = (function (){var statearr_38426 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38426[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38431);

return statearr_38426;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38431,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args38444 = [];
var len__5740__auto___38447 = arguments.length;
var i__5741__auto___38448 = (0);
while(true){
if((i__5741__auto___38448 < len__5740__auto___38447)){
args38444.push((arguments[i__5741__auto___38448]));

var G__38449 = (i__5741__auto___38448 + (1));
i__5741__auto___38448 = G__38449;
continue;
} else {
}
break;
}

var G__38446 = args38444.length;
switch (G__38446) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38444.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__36154__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto__){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto__){
return (function (state_38616){
var state_val_38617 = (state_38616[(1)]);
if((state_val_38617 === (7))){
var inst_38612 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
var statearr_38618_38659 = state_38616__$1;
(statearr_38618_38659[(2)] = inst_38612);

(statearr_38618_38659[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (20))){
var inst_38582 = (state_38616[(7)]);
var inst_38593 = (state_38616[(2)]);
var inst_38594 = cljs.core.next(inst_38582);
var inst_38568 = inst_38594;
var inst_38569 = null;
var inst_38570 = (0);
var inst_38571 = (0);
var state_38616__$1 = (function (){var statearr_38619 = state_38616;
(statearr_38619[(8)] = inst_38571);

(statearr_38619[(9)] = inst_38569);

(statearr_38619[(10)] = inst_38568);

(statearr_38619[(11)] = inst_38570);

(statearr_38619[(12)] = inst_38593);

return statearr_38619;
})();
var statearr_38620_38660 = state_38616__$1;
(statearr_38620_38660[(2)] = null);

(statearr_38620_38660[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (1))){
var state_38616__$1 = state_38616;
var statearr_38621_38661 = state_38616__$1;
(statearr_38621_38661[(2)] = null);

(statearr_38621_38661[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (4))){
var inst_38557 = (state_38616[(13)]);
var inst_38557__$1 = (state_38616[(2)]);
var inst_38558 = (inst_38557__$1 == null);
var state_38616__$1 = (function (){var statearr_38622 = state_38616;
(statearr_38622[(13)] = inst_38557__$1);

return statearr_38622;
})();
if(cljs.core.truth_(inst_38558)){
var statearr_38623_38662 = state_38616__$1;
(statearr_38623_38662[(1)] = (5));

} else {
var statearr_38624_38663 = state_38616__$1;
(statearr_38624_38663[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (15))){
var state_38616__$1 = state_38616;
var statearr_38628_38664 = state_38616__$1;
(statearr_38628_38664[(2)] = null);

(statearr_38628_38664[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (21))){
var state_38616__$1 = state_38616;
var statearr_38629_38665 = state_38616__$1;
(statearr_38629_38665[(2)] = null);

(statearr_38629_38665[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (13))){
var inst_38571 = (state_38616[(8)]);
var inst_38569 = (state_38616[(9)]);
var inst_38568 = (state_38616[(10)]);
var inst_38570 = (state_38616[(11)]);
var inst_38578 = (state_38616[(2)]);
var inst_38579 = (inst_38571 + (1));
var tmp38625 = inst_38569;
var tmp38626 = inst_38568;
var tmp38627 = inst_38570;
var inst_38568__$1 = tmp38626;
var inst_38569__$1 = tmp38625;
var inst_38570__$1 = tmp38627;
var inst_38571__$1 = inst_38579;
var state_38616__$1 = (function (){var statearr_38630 = state_38616;
(statearr_38630[(8)] = inst_38571__$1);

(statearr_38630[(9)] = inst_38569__$1);

(statearr_38630[(10)] = inst_38568__$1);

(statearr_38630[(11)] = inst_38570__$1);

(statearr_38630[(14)] = inst_38578);

return statearr_38630;
})();
var statearr_38631_38666 = state_38616__$1;
(statearr_38631_38666[(2)] = null);

(statearr_38631_38666[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (22))){
var state_38616__$1 = state_38616;
var statearr_38632_38667 = state_38616__$1;
(statearr_38632_38667[(2)] = null);

(statearr_38632_38667[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (6))){
var inst_38557 = (state_38616[(13)]);
var inst_38566 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_38557) : f.call(null,inst_38557));
var inst_38567 = cljs.core.seq(inst_38566);
var inst_38568 = inst_38567;
var inst_38569 = null;
var inst_38570 = (0);
var inst_38571 = (0);
var state_38616__$1 = (function (){var statearr_38633 = state_38616;
(statearr_38633[(8)] = inst_38571);

(statearr_38633[(9)] = inst_38569);

(statearr_38633[(10)] = inst_38568);

(statearr_38633[(11)] = inst_38570);

return statearr_38633;
})();
var statearr_38634_38668 = state_38616__$1;
(statearr_38634_38668[(2)] = null);

(statearr_38634_38668[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (17))){
var inst_38582 = (state_38616[(7)]);
var inst_38586 = cljs.core.chunk_first(inst_38582);
var inst_38587 = cljs.core.chunk_rest(inst_38582);
var inst_38588 = cljs.core.count(inst_38586);
var inst_38568 = inst_38587;
var inst_38569 = inst_38586;
var inst_38570 = inst_38588;
var inst_38571 = (0);
var state_38616__$1 = (function (){var statearr_38635 = state_38616;
(statearr_38635[(8)] = inst_38571);

(statearr_38635[(9)] = inst_38569);

(statearr_38635[(10)] = inst_38568);

(statearr_38635[(11)] = inst_38570);

return statearr_38635;
})();
var statearr_38636_38669 = state_38616__$1;
(statearr_38636_38669[(2)] = null);

(statearr_38636_38669[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (3))){
var inst_38614 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38616__$1,inst_38614);
} else {
if((state_val_38617 === (12))){
var inst_38602 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
var statearr_38637_38670 = state_38616__$1;
(statearr_38637_38670[(2)] = inst_38602);

(statearr_38637_38670[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (2))){
var state_38616__$1 = state_38616;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38616__$1,(4),in$);
} else {
if((state_val_38617 === (23))){
var inst_38610 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
var statearr_38638_38671 = state_38616__$1;
(statearr_38638_38671[(2)] = inst_38610);

(statearr_38638_38671[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (19))){
var inst_38597 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
var statearr_38639_38672 = state_38616__$1;
(statearr_38639_38672[(2)] = inst_38597);

(statearr_38639_38672[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (11))){
var inst_38582 = (state_38616[(7)]);
var inst_38568 = (state_38616[(10)]);
var inst_38582__$1 = cljs.core.seq(inst_38568);
var state_38616__$1 = (function (){var statearr_38640 = state_38616;
(statearr_38640[(7)] = inst_38582__$1);

return statearr_38640;
})();
if(inst_38582__$1){
var statearr_38641_38673 = state_38616__$1;
(statearr_38641_38673[(1)] = (14));

} else {
var statearr_38642_38674 = state_38616__$1;
(statearr_38642_38674[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (9))){
var inst_38604 = (state_38616[(2)]);
var inst_38605 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_38616__$1 = (function (){var statearr_38643 = state_38616;
(statearr_38643[(15)] = inst_38604);

return statearr_38643;
})();
if(cljs.core.truth_(inst_38605)){
var statearr_38644_38675 = state_38616__$1;
(statearr_38644_38675[(1)] = (21));

} else {
var statearr_38645_38676 = state_38616__$1;
(statearr_38645_38676[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (5))){
var inst_38560 = cljs.core.async.close_BANG_(out);
var state_38616__$1 = state_38616;
var statearr_38646_38677 = state_38616__$1;
(statearr_38646_38677[(2)] = inst_38560);

(statearr_38646_38677[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (14))){
var inst_38582 = (state_38616[(7)]);
var inst_38584 = cljs.core.chunked_seq_QMARK_(inst_38582);
var state_38616__$1 = state_38616;
if(inst_38584){
var statearr_38647_38678 = state_38616__$1;
(statearr_38647_38678[(1)] = (17));

} else {
var statearr_38648_38679 = state_38616__$1;
(statearr_38648_38679[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (16))){
var inst_38600 = (state_38616[(2)]);
var state_38616__$1 = state_38616;
var statearr_38649_38680 = state_38616__$1;
(statearr_38649_38680[(2)] = inst_38600);

(statearr_38649_38680[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38617 === (10))){
var inst_38571 = (state_38616[(8)]);
var inst_38569 = (state_38616[(9)]);
var inst_38576 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_38569,inst_38571);
var state_38616__$1 = state_38616;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38616__$1,(13),out,inst_38576);
} else {
if((state_val_38617 === (18))){
var inst_38582 = (state_38616[(7)]);
var inst_38591 = cljs.core.first(inst_38582);
var state_38616__$1 = state_38616;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38616__$1,(20),out,inst_38591);
} else {
if((state_val_38617 === (8))){
var inst_38571 = (state_38616[(8)]);
var inst_38570 = (state_38616[(11)]);
var inst_38573 = (inst_38571 < inst_38570);
var inst_38574 = inst_38573;
var state_38616__$1 = state_38616;
if(cljs.core.truth_(inst_38574)){
var statearr_38650_38681 = state_38616__$1;
(statearr_38650_38681[(1)] = (10));

} else {
var statearr_38651_38682 = state_38616__$1;
(statearr_38651_38682[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto__))
;
return ((function (switch__36040__auto__,c__36154__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____0 = (function (){
var statearr_38655 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38655[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__);

(statearr_38655[(1)] = (1));

return statearr_38655;
});
var cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____1 = (function (state_38616){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38616);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38656){if((e38656 instanceof Object)){
var ex__36044__auto__ = e38656;
var statearr_38657_38683 = state_38616;
(statearr_38657_38683[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38616);

return cljs.core.cst$kw$recur;
} else {
throw e38656;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38684 = state_38616;
state_38616 = G__38684;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__ = function(state_38616){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____1.call(this,state_38616);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__36041__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto__))
})();
var state__36156__auto__ = (function (){var statearr_38658 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38658[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto__);

return statearr_38658;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto__))
);

return c__36154__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args38685 = [];
var len__5740__auto___38688 = arguments.length;
var i__5741__auto___38689 = (0);
while(true){
if((i__5741__auto___38689 < len__5740__auto___38688)){
args38685.push((arguments[i__5741__auto___38689]));

var G__38690 = (i__5741__auto___38689 + (1));
i__5741__auto___38689 = G__38690;
continue;
} else {
}
break;
}

var G__38687 = args38685.length;
switch (G__38687) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38685.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args38692 = [];
var len__5740__auto___38695 = arguments.length;
var i__5741__auto___38696 = (0);
while(true){
if((i__5741__auto___38696 < len__5740__auto___38695)){
args38692.push((arguments[i__5741__auto___38696]));

var G__38697 = (i__5741__auto___38696 + (1));
i__5741__auto___38696 = G__38697;
continue;
} else {
}
break;
}

var G__38694 = args38692.length;
switch (G__38694) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38692.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args38699 = [];
var len__5740__auto___38750 = arguments.length;
var i__5741__auto___38751 = (0);
while(true){
if((i__5741__auto___38751 < len__5740__auto___38750)){
args38699.push((arguments[i__5741__auto___38751]));

var G__38752 = (i__5741__auto___38751 + (1));
i__5741__auto___38751 = G__38752;
continue;
} else {
}
break;
}

var G__38701 = args38699.length;
switch (G__38701) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38699.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38754 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38754,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38754,out){
return (function (state_38725){
var state_val_38726 = (state_38725[(1)]);
if((state_val_38726 === (7))){
var inst_38720 = (state_38725[(2)]);
var state_38725__$1 = state_38725;
var statearr_38727_38755 = state_38725__$1;
(statearr_38727_38755[(2)] = inst_38720);

(statearr_38727_38755[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (1))){
var inst_38702 = null;
var state_38725__$1 = (function (){var statearr_38728 = state_38725;
(statearr_38728[(7)] = inst_38702);

return statearr_38728;
})();
var statearr_38729_38756 = state_38725__$1;
(statearr_38729_38756[(2)] = null);

(statearr_38729_38756[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (4))){
var inst_38705 = (state_38725[(8)]);
var inst_38705__$1 = (state_38725[(2)]);
var inst_38706 = (inst_38705__$1 == null);
var inst_38707 = cljs.core.not(inst_38706);
var state_38725__$1 = (function (){var statearr_38730 = state_38725;
(statearr_38730[(8)] = inst_38705__$1);

return statearr_38730;
})();
if(inst_38707){
var statearr_38731_38757 = state_38725__$1;
(statearr_38731_38757[(1)] = (5));

} else {
var statearr_38732_38758 = state_38725__$1;
(statearr_38732_38758[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (6))){
var state_38725__$1 = state_38725;
var statearr_38733_38759 = state_38725__$1;
(statearr_38733_38759[(2)] = null);

(statearr_38733_38759[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (3))){
var inst_38722 = (state_38725[(2)]);
var inst_38723 = cljs.core.async.close_BANG_(out);
var state_38725__$1 = (function (){var statearr_38734 = state_38725;
(statearr_38734[(9)] = inst_38722);

return statearr_38734;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_38725__$1,inst_38723);
} else {
if((state_val_38726 === (2))){
var state_38725__$1 = state_38725;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38725__$1,(4),ch);
} else {
if((state_val_38726 === (11))){
var inst_38705 = (state_38725[(8)]);
var inst_38714 = (state_38725[(2)]);
var inst_38702 = inst_38705;
var state_38725__$1 = (function (){var statearr_38735 = state_38725;
(statearr_38735[(10)] = inst_38714);

(statearr_38735[(7)] = inst_38702);

return statearr_38735;
})();
var statearr_38736_38760 = state_38725__$1;
(statearr_38736_38760[(2)] = null);

(statearr_38736_38760[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (9))){
var inst_38705 = (state_38725[(8)]);
var state_38725__$1 = state_38725;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38725__$1,(11),out,inst_38705);
} else {
if((state_val_38726 === (5))){
var inst_38702 = (state_38725[(7)]);
var inst_38705 = (state_38725[(8)]);
var inst_38709 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_38705,inst_38702);
var state_38725__$1 = state_38725;
if(inst_38709){
var statearr_38738_38761 = state_38725__$1;
(statearr_38738_38761[(1)] = (8));

} else {
var statearr_38739_38762 = state_38725__$1;
(statearr_38739_38762[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (10))){
var inst_38717 = (state_38725[(2)]);
var state_38725__$1 = state_38725;
var statearr_38740_38763 = state_38725__$1;
(statearr_38740_38763[(2)] = inst_38717);

(statearr_38740_38763[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38726 === (8))){
var inst_38702 = (state_38725[(7)]);
var tmp38737 = inst_38702;
var inst_38702__$1 = tmp38737;
var state_38725__$1 = (function (){var statearr_38741 = state_38725;
(statearr_38741[(7)] = inst_38702__$1);

return statearr_38741;
})();
var statearr_38742_38764 = state_38725__$1;
(statearr_38742_38764[(2)] = null);

(statearr_38742_38764[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38754,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38754,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38746 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_38746[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38746[(1)] = (1));

return statearr_38746;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38725){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38725);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38747){if((e38747 instanceof Object)){
var ex__36044__auto__ = e38747;
var statearr_38748_38765 = state_38725;
(statearr_38748_38765[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38725);

return cljs.core.cst$kw$recur;
} else {
throw e38747;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38766 = state_38725;
state_38725 = G__38766;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38725){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38725);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38754,out))
})();
var state__36156__auto__ = (function (){var statearr_38749 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38749[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38754);

return statearr_38749;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38754,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args38767 = [];
var len__5740__auto___38837 = arguments.length;
var i__5741__auto___38838 = (0);
while(true){
if((i__5741__auto___38838 < len__5740__auto___38837)){
args38767.push((arguments[i__5741__auto___38838]));

var G__38839 = (i__5741__auto___38838 + (1));
i__5741__auto___38838 = G__38839;
continue;
} else {
}
break;
}

var G__38769 = args38767.length;
switch (G__38769) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38767.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38841 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38841,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38841,out){
return (function (state_38807){
var state_val_38808 = (state_38807[(1)]);
if((state_val_38808 === (7))){
var inst_38803 = (state_38807[(2)]);
var state_38807__$1 = state_38807;
var statearr_38809_38842 = state_38807__$1;
(statearr_38809_38842[(2)] = inst_38803);

(statearr_38809_38842[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (1))){
var inst_38770 = (new Array(n));
var inst_38771 = inst_38770;
var inst_38772 = (0);
var state_38807__$1 = (function (){var statearr_38810 = state_38807;
(statearr_38810[(7)] = inst_38772);

(statearr_38810[(8)] = inst_38771);

return statearr_38810;
})();
var statearr_38811_38843 = state_38807__$1;
(statearr_38811_38843[(2)] = null);

(statearr_38811_38843[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (4))){
var inst_38775 = (state_38807[(9)]);
var inst_38775__$1 = (state_38807[(2)]);
var inst_38776 = (inst_38775__$1 == null);
var inst_38777 = cljs.core.not(inst_38776);
var state_38807__$1 = (function (){var statearr_38812 = state_38807;
(statearr_38812[(9)] = inst_38775__$1);

return statearr_38812;
})();
if(inst_38777){
var statearr_38813_38844 = state_38807__$1;
(statearr_38813_38844[(1)] = (5));

} else {
var statearr_38814_38845 = state_38807__$1;
(statearr_38814_38845[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (15))){
var inst_38797 = (state_38807[(2)]);
var state_38807__$1 = state_38807;
var statearr_38815_38846 = state_38807__$1;
(statearr_38815_38846[(2)] = inst_38797);

(statearr_38815_38846[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (13))){
var state_38807__$1 = state_38807;
var statearr_38816_38847 = state_38807__$1;
(statearr_38816_38847[(2)] = null);

(statearr_38816_38847[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (6))){
var inst_38772 = (state_38807[(7)]);
var inst_38793 = (inst_38772 > (0));
var state_38807__$1 = state_38807;
if(cljs.core.truth_(inst_38793)){
var statearr_38817_38848 = state_38807__$1;
(statearr_38817_38848[(1)] = (12));

} else {
var statearr_38818_38849 = state_38807__$1;
(statearr_38818_38849[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (3))){
var inst_38805 = (state_38807[(2)]);
var state_38807__$1 = state_38807;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38807__$1,inst_38805);
} else {
if((state_val_38808 === (12))){
var inst_38771 = (state_38807[(8)]);
var inst_38795 = cljs.core.vec(inst_38771);
var state_38807__$1 = state_38807;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38807__$1,(15),out,inst_38795);
} else {
if((state_val_38808 === (2))){
var state_38807__$1 = state_38807;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38807__$1,(4),ch);
} else {
if((state_val_38808 === (11))){
var inst_38787 = (state_38807[(2)]);
var inst_38788 = (new Array(n));
var inst_38771 = inst_38788;
var inst_38772 = (0);
var state_38807__$1 = (function (){var statearr_38819 = state_38807;
(statearr_38819[(10)] = inst_38787);

(statearr_38819[(7)] = inst_38772);

(statearr_38819[(8)] = inst_38771);

return statearr_38819;
})();
var statearr_38820_38850 = state_38807__$1;
(statearr_38820_38850[(2)] = null);

(statearr_38820_38850[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (9))){
var inst_38771 = (state_38807[(8)]);
var inst_38785 = cljs.core.vec(inst_38771);
var state_38807__$1 = state_38807;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38807__$1,(11),out,inst_38785);
} else {
if((state_val_38808 === (5))){
var inst_38772 = (state_38807[(7)]);
var inst_38780 = (state_38807[(11)]);
var inst_38775 = (state_38807[(9)]);
var inst_38771 = (state_38807[(8)]);
var inst_38779 = (inst_38771[inst_38772] = inst_38775);
var inst_38780__$1 = (inst_38772 + (1));
var inst_38781 = (inst_38780__$1 < n);
var state_38807__$1 = (function (){var statearr_38821 = state_38807;
(statearr_38821[(11)] = inst_38780__$1);

(statearr_38821[(12)] = inst_38779);

return statearr_38821;
})();
if(cljs.core.truth_(inst_38781)){
var statearr_38822_38851 = state_38807__$1;
(statearr_38822_38851[(1)] = (8));

} else {
var statearr_38823_38852 = state_38807__$1;
(statearr_38823_38852[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (14))){
var inst_38800 = (state_38807[(2)]);
var inst_38801 = cljs.core.async.close_BANG_(out);
var state_38807__$1 = (function (){var statearr_38825 = state_38807;
(statearr_38825[(13)] = inst_38800);

return statearr_38825;
})();
var statearr_38826_38853 = state_38807__$1;
(statearr_38826_38853[(2)] = inst_38801);

(statearr_38826_38853[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (10))){
var inst_38791 = (state_38807[(2)]);
var state_38807__$1 = state_38807;
var statearr_38827_38854 = state_38807__$1;
(statearr_38827_38854[(2)] = inst_38791);

(statearr_38827_38854[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38808 === (8))){
var inst_38780 = (state_38807[(11)]);
var inst_38771 = (state_38807[(8)]);
var tmp38824 = inst_38771;
var inst_38771__$1 = tmp38824;
var inst_38772 = inst_38780;
var state_38807__$1 = (function (){var statearr_38828 = state_38807;
(statearr_38828[(7)] = inst_38772);

(statearr_38828[(8)] = inst_38771__$1);

return statearr_38828;
})();
var statearr_38829_38855 = state_38807__$1;
(statearr_38829_38855[(2)] = null);

(statearr_38829_38855[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38841,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38841,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38833 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38833[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38833[(1)] = (1));

return statearr_38833;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38807){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38807);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38834){if((e38834 instanceof Object)){
var ex__36044__auto__ = e38834;
var statearr_38835_38856 = state_38807;
(statearr_38835_38856[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38807);

return cljs.core.cst$kw$recur;
} else {
throw e38834;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38857 = state_38807;
state_38807 = G__38857;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38807){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38807);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38841,out))
})();
var state__36156__auto__ = (function (){var statearr_38836 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38836[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38841);

return statearr_38836;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38841,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args38858 = [];
var len__5740__auto___38932 = arguments.length;
var i__5741__auto___38933 = (0);
while(true){
if((i__5741__auto___38933 < len__5740__auto___38932)){
args38858.push((arguments[i__5741__auto___38933]));

var G__38934 = (i__5741__auto___38933 + (1));
i__5741__auto___38933 = G__38934;
continue;
} else {
}
break;
}

var G__38860 = args38858.length;
switch (G__38860) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args38858.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__36154__auto___38936 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__36154__auto___38936,out){
return (function (){
var f__36155__auto__ = (function (){var switch__36040__auto__ = ((function (c__36154__auto___38936,out){
return (function (state_38902){
var state_val_38903 = (state_38902[(1)]);
if((state_val_38903 === (7))){
var inst_38898 = (state_38902[(2)]);
var state_38902__$1 = state_38902;
var statearr_38904_38937 = state_38902__$1;
(statearr_38904_38937[(2)] = inst_38898);

(statearr_38904_38937[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (1))){
var inst_38861 = [];
var inst_38862 = inst_38861;
var inst_38863 = cljs.core.cst$kw$cljs$core$async_SLASH_nothing;
var state_38902__$1 = (function (){var statearr_38905 = state_38902;
(statearr_38905[(7)] = inst_38862);

(statearr_38905[(8)] = inst_38863);

return statearr_38905;
})();
var statearr_38906_38938 = state_38902__$1;
(statearr_38906_38938[(2)] = null);

(statearr_38906_38938[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (4))){
var inst_38866 = (state_38902[(9)]);
var inst_38866__$1 = (state_38902[(2)]);
var inst_38867 = (inst_38866__$1 == null);
var inst_38868 = cljs.core.not(inst_38867);
var state_38902__$1 = (function (){var statearr_38907 = state_38902;
(statearr_38907[(9)] = inst_38866__$1);

return statearr_38907;
})();
if(inst_38868){
var statearr_38908_38939 = state_38902__$1;
(statearr_38908_38939[(1)] = (5));

} else {
var statearr_38909_38940 = state_38902__$1;
(statearr_38909_38940[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (15))){
var inst_38892 = (state_38902[(2)]);
var state_38902__$1 = state_38902;
var statearr_38910_38941 = state_38902__$1;
(statearr_38910_38941[(2)] = inst_38892);

(statearr_38910_38941[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (13))){
var state_38902__$1 = state_38902;
var statearr_38911_38942 = state_38902__$1;
(statearr_38911_38942[(2)] = null);

(statearr_38911_38942[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (6))){
var inst_38862 = (state_38902[(7)]);
var inst_38887 = inst_38862.length;
var inst_38888 = (inst_38887 > (0));
var state_38902__$1 = state_38902;
if(cljs.core.truth_(inst_38888)){
var statearr_38912_38943 = state_38902__$1;
(statearr_38912_38943[(1)] = (12));

} else {
var statearr_38913_38944 = state_38902__$1;
(statearr_38913_38944[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (3))){
var inst_38900 = (state_38902[(2)]);
var state_38902__$1 = state_38902;
return cljs.core.async.impl.ioc_helpers.return_chan(state_38902__$1,inst_38900);
} else {
if((state_val_38903 === (12))){
var inst_38862 = (state_38902[(7)]);
var inst_38890 = cljs.core.vec(inst_38862);
var state_38902__$1 = state_38902;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38902__$1,(15),out,inst_38890);
} else {
if((state_val_38903 === (2))){
var state_38902__$1 = state_38902;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_38902__$1,(4),ch);
} else {
if((state_val_38903 === (11))){
var inst_38866 = (state_38902[(9)]);
var inst_38870 = (state_38902[(10)]);
var inst_38880 = (state_38902[(2)]);
var inst_38881 = [];
var inst_38882 = inst_38881.push(inst_38866);
var inst_38862 = inst_38881;
var inst_38863 = inst_38870;
var state_38902__$1 = (function (){var statearr_38914 = state_38902;
(statearr_38914[(7)] = inst_38862);

(statearr_38914[(11)] = inst_38880);

(statearr_38914[(12)] = inst_38882);

(statearr_38914[(8)] = inst_38863);

return statearr_38914;
})();
var statearr_38915_38945 = state_38902__$1;
(statearr_38915_38945[(2)] = null);

(statearr_38915_38945[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (9))){
var inst_38862 = (state_38902[(7)]);
var inst_38878 = cljs.core.vec(inst_38862);
var state_38902__$1 = state_38902;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_38902__$1,(11),out,inst_38878);
} else {
if((state_val_38903 === (5))){
var inst_38866 = (state_38902[(9)]);
var inst_38870 = (state_38902[(10)]);
var inst_38863 = (state_38902[(8)]);
var inst_38870__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_38866) : f.call(null,inst_38866));
var inst_38871 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_38870__$1,inst_38863);
var inst_38872 = cljs.core.keyword_identical_QMARK_(inst_38863,cljs.core.cst$kw$cljs$core$async_SLASH_nothing);
var inst_38873 = (inst_38871) || (inst_38872);
var state_38902__$1 = (function (){var statearr_38916 = state_38902;
(statearr_38916[(10)] = inst_38870__$1);

return statearr_38916;
})();
if(cljs.core.truth_(inst_38873)){
var statearr_38917_38946 = state_38902__$1;
(statearr_38917_38946[(1)] = (8));

} else {
var statearr_38918_38947 = state_38902__$1;
(statearr_38918_38947[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (14))){
var inst_38895 = (state_38902[(2)]);
var inst_38896 = cljs.core.async.close_BANG_(out);
var state_38902__$1 = (function (){var statearr_38920 = state_38902;
(statearr_38920[(13)] = inst_38895);

return statearr_38920;
})();
var statearr_38921_38948 = state_38902__$1;
(statearr_38921_38948[(2)] = inst_38896);

(statearr_38921_38948[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (10))){
var inst_38885 = (state_38902[(2)]);
var state_38902__$1 = state_38902;
var statearr_38922_38949 = state_38902__$1;
(statearr_38922_38949[(2)] = inst_38885);

(statearr_38922_38949[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_38903 === (8))){
var inst_38866 = (state_38902[(9)]);
var inst_38870 = (state_38902[(10)]);
var inst_38862 = (state_38902[(7)]);
var inst_38875 = inst_38862.push(inst_38866);
var tmp38919 = inst_38862;
var inst_38862__$1 = tmp38919;
var inst_38863 = inst_38870;
var state_38902__$1 = (function (){var statearr_38923 = state_38902;
(statearr_38923[(7)] = inst_38862__$1);

(statearr_38923[(14)] = inst_38875);

(statearr_38923[(8)] = inst_38863);

return statearr_38923;
})();
var statearr_38924_38950 = state_38902__$1;
(statearr_38924_38950[(2)] = null);

(statearr_38924_38950[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__36154__auto___38936,out))
;
return ((function (switch__36040__auto__,c__36154__auto___38936,out){
return (function() {
var cljs$core$async$state_machine__36041__auto__ = null;
var cljs$core$async$state_machine__36041__auto____0 = (function (){
var statearr_38928 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_38928[(0)] = cljs$core$async$state_machine__36041__auto__);

(statearr_38928[(1)] = (1));

return statearr_38928;
});
var cljs$core$async$state_machine__36041__auto____1 = (function (state_38902){
while(true){
var ret_value__36042__auto__ = (function (){try{while(true){
var result__36043__auto__ = switch__36040__auto__(state_38902);
if(cljs.core.keyword_identical_QMARK_(result__36043__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__36043__auto__;
}
break;
}
}catch (e38929){if((e38929 instanceof Object)){
var ex__36044__auto__ = e38929;
var statearr_38930_38951 = state_38902;
(statearr_38930_38951[(5)] = ex__36044__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_38902);

return cljs.core.cst$kw$recur;
} else {
throw e38929;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__36042__auto__,cljs.core.cst$kw$recur)){
var G__38952 = state_38902;
state_38902 = G__38952;
continue;
} else {
return ret_value__36042__auto__;
}
break;
}
});
cljs$core$async$state_machine__36041__auto__ = function(state_38902){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__36041__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__36041__auto____1.call(this,state_38902);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__36041__auto____0;
cljs$core$async$state_machine__36041__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__36041__auto____1;
return cljs$core$async$state_machine__36041__auto__;
})()
;})(switch__36040__auto__,c__36154__auto___38936,out))
})();
var state__36156__auto__ = (function (){var statearr_38931 = (f__36155__auto__.cljs$core$IFn$_invoke$arity$0 ? f__36155__auto__.cljs$core$IFn$_invoke$arity$0() : f__36155__auto__.call(null));
(statearr_38931[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__36154__auto___38936);

return statearr_38931;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__36156__auto__);
});})(c__36154__auto___38936,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;
